Option Strict On
Option Explicit On 

Public Class Grid
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

        'True  AllPaintingInWmPaint
        'False CacheText
        'False ContainerControl
        'False DoubleBuffer
        'False EnableNotifyMessage
        'False FixedHeight
        'False FixedWidth
        'False Opaque
        'False ResizeRedraw
        'True  Selectable
        'True  StandardClick
        'True  StandardDoubleClick
        'False SupportsTransparentBackColor
        'False UserMouse
        'True  UserPaint

        setstyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.UserPaint, False)

        bmp = New Bitmap(1, 1)
        grp = Graphics.FromImage(bmp)
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        grp.Dispose() : grp = Nothing
        bmp.Dispose() : bmp = Nothing

        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents body As Avand.Shot
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    Friend WithEvents box As Avand.Maskedbox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Grid))
        Me.body = New Avand.Shot
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        Me.box = New Avand.Maskedbox
        Me.SuspendLayout()
        '
        'body
        '
        Me.body.BackColor = System.Drawing.SystemColors.AppWorkspace
        Me.body.Location = New System.Drawing.Point(16, 0)
        Me.body.Name = "body"
        Me.body.Size = New System.Drawing.Size(100, 50)
        Me.body.TabIndex = 2
        Me.body.Text = "Shot1"
        '
        'ImageList1
        '
        Me.ImageList1.ImageSize = New System.Drawing.Size(16, 16)
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
        '
        'box
        '
        Me.box.AcceptsTab = True
        Me.box.AutoSize = False
        Me.box.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.box.Location = New System.Drawing.Point(16, 64)
        Me.box.Mask = Nothing
        Me.box.Name = "box"
        Me.box.Size = New System.Drawing.Size(100, 20)
        Me.box.TabIndex = 3
        Me.box.Text = ""
        Me.box.Visible = False
        '
        'Grid
        '
        Me.BackColor = System.Drawing.SystemColors.AppWorkspace
        Me.Controls.Add(Me.box)
        Me.Controls.Add(Me.body)
        Me.Name = "Grid"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim content As Model10.Content
    Dim band, footer, header As Avand.Shot
    Dim totalRowCount As Integer

    Dim bmp As Bitmap, grp As Graphics
    Dim clear, [partial], rePos, space, inter As Boolean
    Dim curPos, disPos, selPos As Avand.Position
    Dim hsb As HScrollBar, vsb As VScrollBar
    Dim bandWidth, footerHeight, headerHeight, lastPos, totalHeight As Integer

    Private mConnections As Model10.ConnectionCollection
    Private mCurrent As Model10.Current
    Private mLayout As Avand.Layout
    Private mMultiSelect As Model10.MultiSelect
    Private mOleDbConnection As OleDb.OleDbConnection
    Private mParentFormView As Avand.FormView
    Private mPersistRow As DataRowView
    Private mRelation As Model10.Relation
    Private mTextMode As Boolean
    Private mUser As Model10.User

    Public Event RequestBack As EventHandler
    Public Event RowChange As EventHandler
    Public Event RowChangeCommitted As EventHandler
    Public Event RowDoubleClick As EventHandler
    Public Event RowSelect As EventHandler
    Public Event RowEdit As EventHandler
    Public Event RowUpdate As EventHandler
    Public Event RowCancel As EventHandler
    Public Event RowDelete As EventHandler
    Public Event RowDrilldown(ByVal sender As Object, ByVal e As Model10.DrilldownEventArgs)

    Private Sub band_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs)
        body_DoubleClick(sender, e)
    End Sub
    Private Sub band_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Dim x As Integer = GetX()
        Dim y As Integer

        Dim row As Model10.Row
        For Each row In content.Rows
            If y <= e.Y And e.Y <= y + row.Detail.Height Then
                Dim prevPos As Integer = curPos.RowIndex
                If Final(New Avand.Position(row.Index, curPos.MemberName)) Then
                    If mTextMode Then 'Ready For Back
                        box.Visible = False
                        mTextMode = False
                    End If
                    curPos.MemberName = ""
                    Me.Select()
                    SetFocus()

                    If row.Index <> prevPos Then OnRowChangeCommitted(New EventArgs)
                End If
                Exit For
            End If
            y += row.Detail.Height
        Next : row = Nothing
    End Sub
    Private Sub band_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs)
        Try
            If content Is Nothing Then
                e.Graphics.Clear(SystemColors.AppWorkspace)
            Else
                Dim y As Integer

                Dim row As Model10.Row
                For Each row In content.Rows
                    e.Graphics.FillRectangle(SystemBrushes.Control, 0, y, bandWidth, row.Detail.Height)
                    Dim img As Image
                    If row.Index = mCurrent.DataView.Count - 1 + 1 Then
                        If curPos.RowIndex = row.Index Then
                            If RightToLeft = RightToLeft.Yes Then img = ImageList1.Images(2) Else img = ImageList1.Images(1)
                        Else
                            img = ImageList1.Images(0)
                        End If
                    Else
                        If curPos.RowIndex = row.Index Then
                            If mCurrent.DataView(row.Index).IsEdit Then
                                img = ImageList1.Images(3)
                            Else
                                If RightToLeft = RightToLeft.Yes Then img = ImageList1.Images(2) Else img = ImageList1.Images(1)
                            End If
                        End If
                    End If
                    If Not img Is Nothing Then
                        e.Graphics.DrawImage(img, 0, y)
                        img = Nothing
                    End If
                    ControlPaint.DrawBorder3D(e.Graphics, 0, y, bandWidth, row.Detail.Height, Border3DStyle.RaisedInner)

                    y += row.Detail.Height
                Next : row = Nothing

                e.Graphics.FillRectangle(SystemBrushes.AppWorkspace, 0, y, bandWidth, band.Height - y)
            End If
        Catch ex As Exception
            Trace.WriteLine(ex.Message, "Grid/band_Paint")
        End Try
    End Sub
    Private Sub body_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles body.DoubleClick
        Dim y As Integer

        Dim row As Model10.Row
        For Each row In content.Rows
            If row.Index = curPos.RowIndex Then
                OnRowDoubleClick(New EventArgs)
                Exit For
            End If
            y += row.Detail.Height
        Next : row = Nothing
    End Sub
    Private Sub body_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles body.MouseDown
        '   MouseMove selPos           .         Ԙ .
        '---------------------------------------------
        body_MouseMove(sender, e)
        '---------------------------------------------


        If selPos.RowIndex >= 0 Then
            If (e.Button And MouseButtons.Left) = MouseButtons.Left Then disPos = selPos
            Dim colName As String
            If selPos.MemberName <> "" Then colName = selPos.MemberName Else colName = curPos.MemberName
            Final(New Avand.Position(selPos.RowIndex, colName))
            If curPos.RowIndex <> lastPos Then
                OnRowChangeCommitted(New EventArgs)
            End If
        End If
    End Sub
    Private Sub body_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles body.MouseMove
        Dim newMem As Model10.Member
        Dim newPos As New Avand.Position(-1, "")

        Dim x As Integer = GetX()
        Dim y As Integer
        Dim row As Model10.Row

        For Each row In content.Rows
            If y <= e.Y And e.Y <= y + row.Detail.Height Then
                newPos.RowIndex = row.Index

                Dim memAr As Model10.Member() = row.Detail.GetMembers
                If Not memAr Is Nothing Then
                    Dim i As Integer
                    For i = UBound(memAr) To 0 Step -1
                        Dim mem As Model10.Member = memAr(i)
                        If x + mem.Location.X <= e.X And e.X <= x + mem.Location.X + mem.Size.Width And y + mem.Location.Y <= e.Y And e.Y <= y + mem.Location.Y + mem.Size.Height Then
                            newMem = mem
                            newPos.MemberName = mem.Name
                            Exit For
                        End If
                        mem = Nothing
                    Next
                End If
                memAr = Nothing
                Exit For
            End If
            y += row.Detail.Height
        Next : row = Nothing

        If Not selPos.Equals(newPos) Then
            Dim selMem As Model10.Member = GetMem(selPos)
            Dim disMem As Model10.Member = GetMem(disPos)
            If selMem Is Nothing Then
                body.Cursor = Cursors.Default
            Else
                If selMem.GetType Is GetType(Model10.Label) Then
                    If ((e.Button And MouseButtons.Left) = MouseButtons.Left And selMem Is disMem) Or (e.Button And MouseButtons.Left) <> MouseButtons.Left Then
                        body.Cursor = Cursors.Default
                    End If
                ElseIf TypeOf selMem Is Model10.Button Then
                    Dim btn As Model10.Button = CType(selMem, Model10.Button)
                    If (btn.ButtonStyle = Model10.ButtonStyle.Normal Or btn.ButtonStyle = Model10.ButtonStyle.Flat) Then
                        If (e.Button And MouseButtons.Left) = MouseButtons.Left And selMem Is disMem Then
                            y = 0
                            For Each row In content.Rows
                                If row.Index = curPos.RowIndex Then
                                    body.Invalidate(New Rectangle(x + selMem.Location.X, y + selMem.Location.Y, selMem.Size.Width, selMem.Size.Height))
                                    Exit For
                                End If
                                y += row.Detail.Height
                            Next : row = Nothing
                        End If
                    ElseIf btn.ButtonStyle = Model10.ButtonStyle.Link Then
                        If ((e.Button And MouseButtons.Left) = MouseButtons.Left And selMem Is disMem) Or (e.Button And MouseButtons.Left) <> MouseButtons.Left Then
                            body.Cursor = Cursors.Default
                        End If
                    End If
                    btn = Nothing
                End If
            End If
            If newMem Is Nothing Then
                body.Cursor = Cursors.Default
            Else
                If newMem.GetType Is GetType(Model10.Label) Then
                    If ((e.Button And MouseButtons.Left) = MouseButtons.Left And newMem Is disMem) Or (e.Button And MouseButtons.Left) <> MouseButtons.Left Then
                        body.Cursor = Cursors.Hand
                    End If
                ElseIf TypeOf newMem Is Model10.Button Then
                    Dim btn As Model10.Button = CType(newMem, Model10.Button)
                    If (btn.ButtonStyle = Model10.ButtonStyle.Normal Or btn.ButtonStyle = Model10.ButtonStyle.Flat) Then
                        If (e.Button And MouseButtons.Left) = MouseButtons.Left And newMem Is disMem Then
                            y = 0
                            For Each row In content.Rows
                                If row.Index = curPos.RowIndex Then
                                    body.Invalidate(New Rectangle(x + newMem.Location.X, y + newMem.Location.Y, newMem.Size.Width, newMem.Size.Height))
                                    Exit For
                                End If
                                y += row.Detail.Height
                            Next : row = Nothing
                        End If
                    ElseIf btn.ButtonStyle = Model10.ButtonStyle.Link Then
                        If ((e.Button And MouseButtons.Left) = MouseButtons.Left And newMem Is disMem) Or (e.Button And MouseButtons.Left) <> MouseButtons.Left Then
                            body.Cursor = Cursors.Hand
                        End If
                    End If
                    btn = Nothing
                End If
            End If
            selMem = Nothing : disMem = Nothing
            selPos = newPos
        End If
    End Sub
    Private Sub body_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles body.MouseUp
        Dim selMem As Model10.Member = GetMem(selPos)
        Dim disMem As Model10.Member = GetMem(disPos)
        If Not selMem Is Nothing And (e.Button And MouseButtons.Left) = MouseButtons.Left Then
            If selMem Is disMem Then
                'it should be here to body_Paint do properly. it is still in MouseButtons.Left situation.
                'disPos.RowIndex = -1 : disPos.MemberName = ""
                '--------------------------

                Dim x As Integer = GetX()
                Dim y As Integer

                Dim row As Model10.Row
                For Each row In content.Rows
                    If row.Index = curPos.RowIndex Then
                        If selMem.GetType Is GetType(Model10.Label) Then
                            Dim lbl As Model10.Label = CType(selMem, Model10.Label)

                            Application.DoEvents()
                            Cursor.Current = Cursors.WaitCursor
                            '----------------------------------
                            Try
                                Process.Start(lbl.NavigateUrl)
                            Catch ex As Exception
                                MsgBox(ex.Message)
                            End Try
                            '----------------------------------
                            Cursor.Current = Cursors.Default

                            lbl = Nothing
                        ElseIf TypeOf selMem Is Model10.CheckBox Then
                            If (e.Button And MouseButtons.Left) = MouseButtons.Left Then
                                Check(CType(selMem, Model10.CheckBox))
                            End If
                        ElseIf TypeOf selMem Is Model10.Button Then
                            Dim btn As Model10.Button = CType(selMem, Model10.Button)
                            If (btn.ButtonStyle = Model10.ButtonStyle.Normal Or btn.ButtonStyle = Model10.ButtonStyle.Flat) Then
                                If (e.Button And MouseButtons.Left) = MouseButtons.Left Then
                                    body.Invalidate(New Rectangle(x + selMem.Location.X, y + selMem.Location.Y, selMem.Size.Width, selMem.Size.Height))
                                End If
                            End If
                            Press(btn)
                            btn = Nothing
                        End If
                        Exit For
                    End If
                    y += row.Detail.Height
                Next : row = Nothing
            End If
            selPos.RowIndex = -1 : selPos.MemberName = ""
        End If
        selMem = Nothing : disMem = Nothing
    End Sub
    Private Sub body_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles body.Paint
        Try
            If content Is Nothing Then
                e.Graphics.Clear(SystemColors.AppWorkspace)
                e.Graphics.DrawString("There is nothing to show...", Font, SystemBrushes.HighlightText, 8, 8)
            Else
                Dim x As Integer = GetX()
                Dim y As Integer

                Dim row As Model10.Row
                For Each row In content.Rows
                    Dim b As SolidBrush
                    Dim fColor As New Color
                    If curPos.RowIndex = row.Index Then
                        b = New SolidBrush(row.Detail.SelectionBackColor)
                        fColor = row.Detail.SelectionForeColor
                    Else
                        b = New SolidBrush(row.Detail.BackColor)
                    End If
                    e.Graphics.FillRectangle(b, 0, y, body.Width, row.Detail.Height)
                    b.Dispose() : b = Nothing

                    DrawMembers(row.Detail.Members, e, x, y, fColor)

                    If curPos.RowIndex = row.Index And Me.Focused Then
                        If curPos.MemberName = "" Then
                            ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(0, y, body.Width, row.Detail.Height), row.Detail.SelectionForeColor, row.Detail.SelectionBackColor)
                        Else
                            Dim mem As Model10.Member = row.Detail.Members(curPos.MemberName)
                            If Not mem Is Nothing Then
                                Dim t As Type = mem.GetType
                                If t Is GetType(Model10.Label) Then
                                    Dim lbl As Model10.Label = CType(mem, Model10.Label)
                                    ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(x + lbl.Location.X, y + lbl.Location.Y, lbl.Size.Width, lbl.Size.Height), row.Detail.SelectionForeColor, row.Detail.SelectionBackColor)
                                    lbl = Nothing
                                ElseIf t Is GetType(Model10.PictureBox) Then
                                    Dim pic As Model10.PictureBox = CType(mem, Model10.PictureBox)
                                    ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(x + pic.Location.X, y + pic.Location.Y, pic.Size.Width, pic.Size.Height), row.Detail.SelectionForeColor, row.Detail.SelectionBackColor)
                                    pic = Nothing
                                ElseIf t Is GetType(Model10.CheckBox) Then
                                    Dim chk As Model10.CheckBox = CType(mem, Model10.CheckBox)
                                    ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(x + chk.Location.X, y + chk.Location.Y, chk.Size.Width, chk.Size.Height), row.Detail.SelectionForeColor, row.Detail.SelectionBackColor)
                                    chk = Nothing
                                ElseIf TypeOf mem Is Model10.Button Then
                                    Dim btn As Model10.Button = CType(mem, Model10.Button)
                                    If (body.MouseButtons And MouseButtons.Left) = MouseButtons.Left Then
                                        Dim selMem As Model10.Member = GetMem(selPos)
                                        Dim disMem As Model10.Member = GetMem(disPos)
                                        If mem Is selMem And mem Is disMem Then
                                            btn.DrawPressed(e.Graphics, btn.Text, x, y, Me.RightToLeft, row.Detail.SelectionForeColor)
                                        End If
                                        selMem = Nothing : disMem = Nothing
                                    End If
                                    If space Then
                                        btn.DrawPressed(e.Graphics, btn.Text, x, y, Me.RightToLeft, row.Detail.SelectionForeColor)
                                    End If
                                    If btn.ButtonStyle = Model10.ButtonStyle.Normal Then
                                        ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(x + btn.Location.X + 3, y + btn.Location.Y + 3, btn.Size.Width - 6, btn.Size.Height - 6), row.Detail.SelectionForeColor, row.Detail.SelectionBackColor)
                                    ElseIf btn.ButtonStyle = Model10.ButtonStyle.Flat Then
                                        ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(x + btn.Location.X + 2, y + btn.Location.Y + 2, btn.Size.Width - 4, btn.Size.Height - 4), row.Detail.SelectionForeColor, row.Detail.SelectionBackColor)
                                    Else
                                        ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(x + btn.Location.X, y + btn.Location.Y, btn.Size.Width, btn.Size.Height), row.Detail.SelectionForeColor, row.Detail.SelectionBackColor)
                                    End If
                                    btn = Nothing
                                End If
                                t = Nothing
                                mem = Nothing
                            End If
                        End If
                    End If

                    y += row.Detail.Height
                Next : row = Nothing

                e.Graphics.FillRectangle(SystemBrushes.AppWorkspace, 0, y, body.Width, body.Height - y)
            End If
        Catch ex As Exception
            Trace.WriteLine(ex.Message, "Grid/body_Paint")
        End Try
    End Sub
    Private Sub footer_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs)
        Try
            Dim x As Integer = GetX()
            If RightToLeft = RightToLeft.Yes Then x -= 0 Else x += bandWidth
            e.Graphics.FillRectangle(New SolidBrush(content.GroupFooter.BackColor), 0, 0, footer.Width, content.GroupFooter.Height)
            DrawMembers(content.GroupFooter.Members, e, x, 0, Nothing)
        Catch ex As Exception
            Trace.WriteLine(ex.Message, "Grid/footer_Paint")
        End Try
    End Sub
    Private Sub header_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs)
        Try
            Dim x As Integer = GetX()
            If RightToLeft = RightToLeft.Yes Then x -= 0 Else x += bandWidth
            e.Graphics.FillRectangle(New SolidBrush(content.GroupHeader.BackColor), 0, 0, header.Width, content.GroupHeader.Height)
            DrawMembers(content.GroupHeader.Members, e, x, 0, Nothing)
        Catch ex As Exception
            Trace.WriteLine(ex.Message, "Grid/header_Paint")
        End Try
    End Sub
    Private Sub hsb_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        FitBox()

        If Not header Is Nothing Then header.Refresh()
        '-------------------
        body.Refresh()
        '-------------------
        If Not footer Is Nothing Then footer.Refresh()
    End Sub
    Private Sub box_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles box.KeyDown
        Select Case e.KeyCode
            Case Keys.Left
                Dim handle As Boolean
                If box.RightToLeft = RightToLeft.Yes Then
                    If box.SelectionStart + box.SelectionLength = box.Length Then handle = True
                Else
                    If box.SelectionStart = 0 Then handle = True
                End If
                If handle Then
                    KeyDowning(e.KeyCode, e.Shift)
                    e.Handled = True
                Else
                    SetRow(curPos)
                End If
            Case Keys.Right
                Dim handle As Boolean
                If box.RightToLeft = RightToLeft.Yes Then
                    If box.SelectionStart = 0 Then handle = True
                Else
                    If box.SelectionStart + box.SelectionLength = box.Length Then handle = True
                End If
                If handle Then
                    KeyDowning(e.KeyCode, e.Shift)
                    e.Handled = True
                Else
                    SetRow(curPos)
                End If
            Case Keys.Up, Keys.Down, Keys.PageUp, Keys.PageDown, Keys.Tab
                KeyDowning(e.KeyCode, e.Shift)
                e.Handled = True
            Case Keys.Escape
                If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
                    Dim mem As Model10.Member = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
                    If Not mem Is Nothing Then
                        If mem.GetType Is GetType(Model10.TextBox) Then
                            Dim txt As Model10.TextBox = CType(mem, Model10.TextBox)
                            If txt.DataField <> "" And txt.ParentRelation Is Nothing Then
                                Dim str As String
                                '----------------
                                Dim obj As Object = mCurrent.RowData(txt.DataField)
                                If Not IsDBNull(obj) Then str = obj.ToString
                                obj = Nothing
                                '----------------
                                If str = Nothing Then str = txt.Text
                                If box.Text = str Then
                                    KeyDowning(e.KeyCode, e.Shift)
                                Else
                                    box.Text = str
                                    box.SelectAll()

                                    SetRow(curPos)
                                End If
                            Else
                                KeyDowning(e.KeyCode, e.Shift)
                            End If
                            txt = Nothing
                        Else
                            KeyDowning(e.KeyCode, e.Shift)
                        End If
                        mem = Nothing
                    End If
                Else
                    If mTextMode Then 'Ready For Back
                        box.Visible = False
                        mTextMode = False
                    End If
                    curPos.MemberName = ""
                    Me.Select()
                    SetFocus()
                End If
            Case Keys.Space
                KeyDowning(e.KeyCode, e.Shift)
            Case Keys.Delete
                If Not mTextMode Then KeyDowning(e.KeyCode, e.Shift)
        End Select
        If Not mTextMode Then e.Handled = True
    End Sub
    Private Sub box_KeyUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles box.KeyUp
        KeyUpping(e.KeyCode)
    End Sub
    Private Sub box_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles box.KeyPress
        If e.KeyChar = Microsoft.VisualBasic.ChrW(9) Then e.Handled = True
    End Sub
    Private Sub box_MouseWheel(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles box.MouseWheel
        MouseWheeling(e)
    End Sub
    Private Sub box_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles box.TextChanged
        If mTextMode Then Editing()
    End Sub
    Private Sub vsb_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        FillBody(vsb.Value)
        If vsb.Value = 0 Then OnResize(New EventArgs)
        Mousing()

        body.Refresh()
        If Not band Is Nothing Then band.Refresh()
    End Sub

    Private Function Final(ByVal pos As Avand.Position, Optional ByVal force As Boolean = False) As Boolean
        Final = True
        If mCurrent.RowData Is Nothing Then
            SetRow(pos)
        Else
            Dim isNew As Boolean = mCurrent.RowData.IsNew
            Dim isEdit As Boolean = mCurrent.RowData.IsEdit
            If Not isEdit Then
                SetRow(pos)
            Else
                Dim isException As Boolean
                If pos.RowIndex <> curPos.RowIndex Then force = True
                Dim myRow As Model10.Row = GetRow(curPos.RowIndex)

                Dim mem As Model10.Member = myRow.Detail.Members(curPos.MemberName)
                If mem Is Nothing Then
                    If Not force Then SetRow(pos)
                Else
                    If Not mem.GetType Is GetType(Model10.TextBox) Then
                        If Not force Then SetRow(pos)
                    Else
                        Dim txt As Model10.TextBox = CType(mem, Model10.TextBox)
                        If txt.DataField = "" Then 'Or Not txt.ParentRelation Is Nothing
                            If Not force Then SetRow(pos)
                        Else
                            If box.CheckMask Then
                                Try
                                    Dim str As String
                                    If txt.ParentRelation Is Nothing Then
                                        Try
                                            Dim obj As Object = mCurrent.RowData(txt.DataField)
                                            If Not IsDBNull(obj) Then str = Model10.FFormat(obj, txt.Format)
                                            obj = Nothing
                                        Catch ex As Exception
                                        End Try
                                        If str = box.Text Then
                                            If Not force Then SetRow(pos)
                                        Else
                                            If box.Mask <> "" And box.Text = "" Then
                                                mCurrent.RowData(txt.DataField) = DBNull.Value
                                            Else
                                                mCurrent.RowData(txt.DataField) = box.Text 'GetText
                                            End If
                                        End If
                                    Else
                                        Dim r As DataRow = mCurrent.RowData.Row.GetParentRow(txt.ParentRelation.DataRelation)
                                        If Not r Is Nothing Then
                                            Try
                                                Dim obj As Object = r(txt.DataField)
                                                If Not IsDBNull(obj) Then str = Model10.FFormat(obj, txt.Format)
                                                obj = Nothing
                                            Catch ex As Exception
                                            End Try
                                        End If
                                        If str = box.Text Then
                                            If Not force Then SetRow(pos)
                                        Else
                                            Dim key() As Object
                                            Dim i As Integer
                                            Dim s As String

                                            Dim m As Model10.Member
                                            For Each m In myRow.Detail.GetMembers
                                                If TypeOf m Is Model10.TextBox Then
                                                    Dim t As Model10.TextBox = CType(m, Model10.TextBox)
                                                    If t.ParentRelation Is txt.ParentRelation Then
                                                        If t Is txt Then
                                                            Try
                                                                ReDim Preserve key(i)
                                                                key(i) = box.Text
                                                                s &= ", " & t.DataField
                                                                i += 1
                                                            Catch ex As Exception
                                                            End Try
                                                            Exit For
                                                        Else
                                                            If Not r Is Nothing Then
                                                                Try
                                                                    ReDim Preserve key(i)
                                                                    key(i) = r(t.DataField)
                                                                    s &= ", " & t.DataField
                                                                    i += 1
                                                                Catch ex As Exception
                                                                End Try
                                                            End If
                                                        End If
                                                    End If
                                                    t = Nothing
                                                End If
                                            Next : m = Nothing

                                            If s <> "" Then
                                                s = s.Substring(2)

                                                Dim dv As DataView = txt.ParentRelation.ParentTable.DataTable.DefaultView
                                                dv.Sort = s
                                                Dim f As Integer = dv.Find(key)
                                                If f >= 0 Then
                                                    For i = 0 To UBound(txt.ParentRelation.DataRelation.ChildColumns)
                                                        mCurrent.RowData(txt.ParentRelation.DataRelation.ChildColumns(i).ColumnName) = dv(f)(txt.ParentRelation.DataRelation.ParentColumns(i).ColumnName)
                                                    Next
                                                End If
                                                dv = Nothing
                                            End If

                                            key = Nothing
                                        End If
                                        r = Nothing

                                        'Dim row As DataRow
                                        'For Each row In txt.ParentRelation.ParentTable.DataTable.Rows
                                        '    If CStr(row(txt.DataField)).ToLower = box.GetText.ToLower Then
                                        '        Dim i As Integer
                                        '        For i = 0 To UBound(txt.ParentRelation.DataRelation.ChildColumns)
                                        '            mCurrent.RowData(txt.ParentRelation.DataRelation.ChildColumns(i).ColumnName) = row(txt.ParentRelation.DataRelation.ParentColumns(i).ColumnName)
                                        '        Next
                                        '        Exit For
                                        '    End If
                                        'Next : row = Nothing
                                    End If
                                    If Not force Then
                                        ReRow()
                                        If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                                        SetRow(pos)
                                        OnResize(New EventArgs)
                                        body.Invalidate()
                                    End If
                                Catch ex As Exception
                                    Final = False
                                    isException = True
                                    SetRow(curPos)
                                    Avand.DataError.ShowError(ex, MessageBoxIcon.Exclamation)
                                    pos.RowIndex = curPos.RowIndex
                                    pos.MemberName = curPos.MemberName
                                End Try
                            Else
                                Final = False
                                isException = True
                                SetRow(curPos)
                                MsgBox("The text dose not match mask property.")
                                pos.RowIndex = curPos.RowIndex
                                pos.MemberName = curPos.MemberName
                            End If
                        End If
                        txt = Nothing
                    End If
                    mem = Nothing
                End If
                If force And Not isException Then
                    Try
                        ReadLabels(myRow)
                        ''Fill New-------------------
                        'If Not mCurrent.ParaRow Is Nothing Then
                        '    If isNew Then
                        '        If Not mCurrent.Table.OleDbDataAdapter.InsertCommand Is Nothing Then
                        '            Dim prm As OleDb.OleDbParameter
                        '            For Each prm In mCurrent.Table.OleDbDataAdapter.InsertCommand.Parameters
                        '                If Not Include(prm.SourceColumn, mCurrent.RowData) And Include(prm.SourceColumn, mCurrent.ParaRow) Then
                        '                    prm.Value = mCurrent.ParaRow(prm.SourceColumn)
                        '                End If
                        '            Next : prm = Nothing
                        '        End If
                        '    Else
                        '        If Not mCurrent.Table.OleDbDataAdapter.UpdateCommand Is Nothing Then
                        '            Dim prm As OleDb.OleDbParameter
                        '            For Each prm In mCurrent.Table.OleDbDataAdapter.UpdateCommand.Parameters
                        '                If Not Include(prm.SourceColumn, mCurrent.RowData) And Include(prm.SourceColumn, mCurrent.ParaRow) Then
                        '                    prm.Value = mCurrent.ParaRow(prm.SourceColumn)
                        '                End If
                        '            Next : prm = Nothing
                        '        End If
                        '    End If
                        'End If
                        ''---------------------------
                        mCurrent.RowData.EndEdit()
                        If mLayout Is Nothing Then
                            If mCurrent.Table.AutoSave Then
                                Application.DoEvents()
                                Cursor.Current = Cursors.WaitCursor
                                '----------------------------------
                                Try
                                    '---------------------------Special
                                    'If mCurrent.Table.UpdateCommand.CommandText = "UPDATE TempTable SET TempColum = TempColumn" Then
                                    '    UpdateSpecial(mCurrent)
                                    'Else
                                    mCurrent.Table.UpdateForward()
                                    'End If
                                    'mCurrent.RowData.Row.AcceptChanges()
                                    mCurrent.Table.DataTable.AcceptChanges() ' ϡ      
                                Catch ex As Exception
                                    'mCurrent.RowData.Row.RejectChanges() 
                                    mCurrent.Table.DataTable.RejectChanges() ' ϡ      
                                    If Not mCurrent.DataRow Is Nothing Then
                                        Dim col As DataColumn
                                        For Each col In mCurrent.DataRow.Row.Table.Columns
                                            If Not col.ReadOnly Then
                                                mCurrent.DataRow.Row(col) = mCurrent.DataRow.Row(col)
                                                Exit For
                                            End If
                                        Next : col = Nothing
                                    End If
                                    Final = False
                                    Avand.DataError.ShowError(ex, MessageBoxIcon.Error)
                                End Try
                                '----------------------------------
                                Cursor.Current = Cursors.Default
                            End If
                        Else
                            'mCurrent.RowData.Row.AcceptChanges()
                            mCurrent.Table.DataTable.AcceptChanges() ' ϡ      
                        End If

                        clear = True
                        totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                        If pos.RowIndex > totalRowCount - 1 Then pos.RowIndex = totalRowCount - 1
                        If pos.RowIndex > mCurrent.DataView.Count - 1 Then
                            mCurrent.RowData = Nothing
                        Else
                            mCurrent.RowData = mCurrent.DataView(pos.RowIndex)
                        End If
                        rePos = True : mTextMode = False
                        If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                        SetRow(pos)
                        OnResize(New EventArgs)

                        OnRowUpdate(New EventArgs)
                        If Not isNew And Not mParentFormView Is Nothing Then
                            mParentFormView.Grid1.Fill()
                        End If
                    Catch ex As Exception
                        ReRow() '      Ԙ        
                        If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                        SetRow(curPos)
                        OnResize(New EventArgs)
                        body.Invalidate()
                        If Not band Is Nothing Then band.Invalidate()

                        Final = False
                        Avand.DataError.ShowError(ex, MessageBoxIcon.Exclamation)
                        pos.RowIndex = curPos.RowIndex
                        pos.MemberName = curPos.MemberName
                    End Try
                End If
                myRow = Nothing
            End If
        End If
    End Function
    '---------------------------Special
    'Private Sub UpdateSpecial(ByVal c As Model10.Current)
    '    If CStr(c.RowData!PatientAlternativeValue).Trim <> "" Or CStr(c.RowData!PatientAlternativeDesc).Trim <> "" Then c.RowData!Checked = True
    '    Dim f As Boolean
    '    For Each r As DataRow In c.RowData.Row.GetChildRows("AlternativeAlternative")
    '        If CBool(r!Checked) Then
    '            f = True
    '            Exit For
    '        End If
    '    Next
    '    If f Then c.RowData!Checked = True
    '    If CBool(c.RowData!Checked) Then
    '        CheckParent(c.RowData.Row.GetParentRow("AlternativeAlternative"), CInt(c.Table.SelectCommand.Parameters(0).Value), c.Table.UpdateCommand.Connection.OleDbConnection)
    '    Else
    '        UnCheckParent(c.RowData.Row.GetParentRow("AlternativeAlternative"), CInt(c.Table.SelectCommand.Parameters(0).Value), c.Table.UpdateCommand.Connection.OleDbConnection)
    '    End If
    '    UpdateMe(c.RowData.Row, CInt(c.Table.SelectCommand.Parameters(0).Value), c.Table.UpdateCommand.Connection.OleDbConnection)
    'End Sub
    'Private Sub CheckParent(ByVal dr As DataRow, ByVal patientID As Integer, ByVal c As OleDb.OleDbConnection)
    '    If Not dr Is Nothing Then
    '        If Not CBool(dr!Checked) Then
    '            dr!Checked = True
    '            UpdateMe(dr, patientID, c)
    '        End If
    '        CheckParent(dr.GetParentRow("AlternativeAlternative"), patientID, c)
    '    End If
    'End Sub
    'Private Sub UnCheckParent(ByVal dr As DataRow, ByVal patientID As Integer, ByVal c As OleDb.OleDbConnection)
    '    If Not dr Is Nothing Then
    '        Dim f As Boolean
    '        For Each r As DataRow In dr.GetChildRows("AlternativeAlternative")
    '            If CBool(r!Checked) Then
    '                f = True
    '                Exit For
    '            End If
    '        Next
    '        If Not f And CStr(dr!PatientAlternativeValue).Trim = "" And CStr(dr!PatientAlternativeDesc).Trim = "" Then
    '            If CBool(dr!Checked) Then
    '                dr!Checked = False
    '                UpdateMe(dr, patientID, c)
    '            End If
    '            UnCheckParent(dr.GetParentRow("AlternativeAlternative"), patientID, c)
    '        End If
    '    End If
    'End Sub
    'Private Sub UpdateMe(ByVal dr As DataRow, ByVal patientID As Integer, ByVal cn As OleDb.OleDbConnection)
    '    Dim cm As New OleDb.OleDbCommand("SELECT PatientAlternativeID FROM PatientAlternative WHERE PatientID = @PatientID AND AlternativeID = @AlternativeID", cn)
    '    cm.Parameters.Add("@PatientID", OleDb.OleDbType.Integer).Value = patientID
    '    cm.Parameters.Add("@AlternativeID", OleDb.OleDbType.Integer).Value = dr!AlternativeID
    '    Dim o As Object = cm.ExecuteScalar
    '    If o Is Nothing Then
    '        If CBool(dr!Checked) Then
    '            cm.CommandText = "INSERT INTO PatientAlternative (PatientID, AlternativeID, PatientAlternativeValue, PatientAlternativeDesc) VALUES (@PatientID, @AlternativeID, @PatientAlternativeValue, @PatientAlternativeDesc)"
    '            cm.Parameters.Clear()
    '            cm.Parameters.Add("@PatientID", OleDb.OleDbType.Integer).Value = patientID
    '            cm.Parameters.Add("@AlternativeID", OleDb.OleDbType.Integer).Value = dr!AlternativeID
    '            cm.Parameters.Add("@PatientAlternativeValue", OleDb.OleDbType.VarChar, 255).Value = dr!PatientAlternativeValue
    '            cm.Parameters.Add("@PatientAlternativeDesc", OleDb.OleDbType.VarChar, 1000).Value = dr!PatientAlternativeDesc
    '            cm.ExecuteNonQuery()
    '        End If
    '    Else
    '        Dim PatientAlternativeID As Integer = CInt(o)
    '        If CBool(dr!Checked) Then
    '            cm.CommandText = "UPDATE PatientAlternative SET PatientAlternativeValue = @PatientAlternativeValue, PatientAlternativeDesc = @PatientAlternativeDesc WHERE PatientAlternativeID = @PatientAlternativeID"
    '            cm.Parameters.Clear()
    '            cm.Parameters.Add("@PatientAlternativeValue", OleDb.OleDbType.VarChar, 255).Value = dr!PatientAlternativeValue
    '            cm.Parameters.Add("@PatientAlternativeDesc", OleDb.OleDbType.VarChar, 1000).Value = dr!PatientAlternativeDesc
    '            cm.Parameters.Add("@PatientAlternativeID", OleDb.OleDbType.Integer).Value = PatientAlternativeID
    '            cm.ExecuteNonQuery()
    '        Else
    '            cm.CommandText = "DELETE FROM PatientAlternative WHERE PatientAlternativeID = @PatientAlternativeID"
    '            cm.Parameters.Clear()
    '            cm.Parameters.Add("@PatientAlternativeID", OleDb.OleDbType.Integer).Value = PatientAlternativeID
    '            cm.ExecuteNonQuery()
    '        End If
    '    End If
    'End Sub
    '---------------------------Special
    Private Function GetMem(ByVal pos As Avand.Position) As Model10.Member
        If content.Rows.Count > 0 And pos.MemberName <> "" Then
            If content.Rows(0).Index <= pos.RowIndex And pos.RowIndex <= content.Rows(content.Rows.Count - 1).Index Then
                Return content.Rows(pos.RowIndex - content.Rows(0).Index).Detail.Members(pos.MemberName)
            End If
        End If
    End Function
    Private Function GetRow(ByVal rowIndex As Integer) As Model10.Row
        If content.Rows.Count = 0 Then
            GetRow = NewRow(rowIndex)
        Else
            If content.Rows(0).Index <= rowIndex And rowIndex <= content.Rows(content.Rows.Count - 1).Index Then
                GetRow = content.Rows(rowIndex - content.Rows(0).Index)
            Else
                GetRow = NewRow(rowIndex)
            End If
        End If
    End Function
    Private Function GetX() As Integer
        Dim w As Integer = Width - bandWidth
        '---------------
        If Not vsb Is Nothing Then w -= vsb.Width

        If RightToLeft = RightToLeft.Yes Then
            GetX = w - mCurrent.Table.Width
            If Not hsb Is Nothing Then GetX += hsb.Value
        Else
            GetX = 0
            If Not hsb Is Nothing Then GetX += -hsb.Value
        End If
    End Function
    'Private Function Include(ByVal str As String, ByVal dr As DataRowView) As Boolean
    '    Dim col As DataColumn
    '    For Each col In dr.DataView.Table.Columns
    '        If col.ColumnName.Trim.ToLower = str.Trim.ToLower Then Return True
    '    Next : col = Nothing
    'End Function
    Private Function IndexOf(ByVal memAr As Model10.Member(), ByVal memberName As String) As Integer
        memberName = memberName.Trim.ToLower
        Dim i As Integer

        Dim mem As Model10.Member
        For Each mem In memAr
            If mem.Name.Trim.ToLower = memberName Then Return i
            i += 1
        Next : mem = Nothing
    End Function
    Private Function NewRow(ByVal rowIndex As Integer) As Model10.Row
        NewRow = New Model10.Row
        NewRow.Index = rowIndex
        Dim bkColor As Color
        If rowIndex Mod 2 = 0 Then
            bkColor = mCurrent.Table.Detail.BackColor
        Else
            bkColor = mCurrent.Table.Detail.AlternatingBackColor
        End If
        NewRow.Detail = New Model10.Detail(mCurrent.Table.Detail, bkColor)
        If rowIndex <= mCurrent.DataView.Count - 1 Then
            Dim dr As DataRowView = mCurrent.DataView(rowIndex)
            If Not dr.IsEdit And mLayout Is Nothing Then
                Try
                    If mCurrent.Table.AutoFill Then Model10.[Global].FillChildData(mCurrent.Table, mCurrent.ParaRow, dr, mRelation)
                Catch ex As Exception
                    MsgBox(ex.Message)
                End Try
            End If
            FillSection(NewRow.Detail, mCurrent.Table.Detail.Members, dr, rowIndex, mCurrent.DataView.Count)
        Else
            FillSection(NewRow.Detail, mCurrent.Table.Detail.Members, Nothing, rowIndex, mCurrent.DataView.Count)
        End If
    End Function

    Private Sub Check(ByVal chk As Model10.CheckBox)
        Dim [readOnly] As Boolean
        If chk.DataField = "" Or Not chk.ParentRelation Is Nothing Then
            [readOnly] = True
        Else
            Try
                Dim dc As DataColumn = mCurrent.Table.DataTable.Columns(chk.DataField)
                If curPos.RowIndex > mCurrent.DataView.Count - 1 Then
                    If dc.ReadOnly Then [readOnly] = True
                Else
                    If mCurrent.RowData.IsNew Then
                        If dc.ReadOnly Then [readOnly] = True
                    Else
                        If mCurrent.Table.UpdateCommand Is Nothing Then
                            [readOnly] = True
                        Else
                            If dc.ReadOnly Then [readOnly] = True
                        End If
                    End If
                End If
                dc = Nothing
            Catch ex As Exception
                [readOnly] = True
            End Try
        End If
        If Not [readOnly] Then
            Dim wasEdit, isNew As Boolean
            Dim dr As DataRowView
            If mCurrent.RowData Is Nothing Then
                dr = mCurrent.DataView.AddNew
                mCurrent.RowData = dr '  
                isNew = True
            Else
                dr = mCurrent.RowData
                wasEdit = dr.IsEdit
                'If Not mMultiSelect Is Nothing Then
                '    If mMultiSelect.DataTable Is mCurrent.Table And mMultiSelect.SelectionField.Trim.ToLower = chk.DataField.Trim.ToLower Then
                '        wasEdit = True
                '    End If
                'End If
                If Not wasEdit Then dr.BeginEdit()
            End If
            Try
                chk.Checked = Not chk.Checked
                dr(chk.DataField) = chk.Checked
                '-------------------
                If isNew Then
                    ReRow()
                    totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                    If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                    OnResize(New EventArgs)
                Else
                    If Not wasEdit Then
                        ReRow()
                        OnResize(New EventArgs)
                    End If
                End If
                SetRow(curPos)
                '-------------------
                Dim y As Integer

                Dim row As Model10.Row
                For Each row In content.Rows
                    If row.Index = curPos.RowIndex Then
                        If isNew Then
                            body.Invalidate(New Rectangle(0, y, body.Width, body.Height - y))
                            If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, band.Height - y))
                        Else
                            If wasEdit Then
                                body.Invalidate(New Rectangle(GetX() + chk.Location.X, y + chk.Location.Y, chk.Size.Width, chk.Size.Height))
                            Else
                                body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                                If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, 16))
                            End If
                        End If
                        Exit For
                    End If
                    y += row.Detail.Height
                Next : row = Nothing
                '-------------------
                If Not wasEdit Then OnRowEdit(New EventArgs)
                If Not mMultiSelect Is Nothing Then
                    If mMultiSelect.DataTable Is mCurrent.Table And mMultiSelect.SelectionField.Trim.ToLower = chk.DataField.Trim.ToLower Then
                        Updating()
                    End If
                End If
            Catch ex As Exception
                If Not wasEdit Then dr.CancelEdit()
                SetRow(curPos)
                MsgBox(ex.Message)
            End Try
            dr = Nothing
        End If
    End Sub
    Private Sub DrawMembers(ByVal members As Model10.MemberCollection, ByVal e As Windows.Forms.PaintEventArgs, ByVal x As Integer, ByVal y As Integer, ByVal fColor As Color)
        Dim mem As Model10.Member
        For Each mem In members
            If mem.Visible Then
                Dim b As Boolean = True
                If Not hsb Is Nothing Then
                    b = e.ClipRectangle.IntersectsWith(New Drawing.Rectangle(x + mem.Location.X, y + mem.Location.Y, mem.Size.Width, mem.Size.Height))
                End If
                If b Then
                    If mem.GetType Is GetType(Model10.Line) Then
                        CType(mem, Model10.Line).Draw(e.Graphics, x, y)
                    ElseIf mem.GetType Is GetType(Model10.Frame) Then
                        CType(mem, Model10.Frame).Draw(e.Graphics, x, y)
                    ElseIf TypeOf mem Is Model10.Label Then
                        Dim lbl As Model10.Label = CType(mem, Model10.Label)
                        lbl.Draw(e.Graphics, lbl.Text, x, y, Me.RightToLeft, fColor)
                        lbl = Nothing
                    ElseIf TypeOf mem Is Model10.PictureBox Then
                        Dim pic As Model10.PictureBox = CType(mem, Model10.PictureBox)
                        If pic.Image Is Nothing Then
                            CType(mem, Model10.Frame).Draw(e.Graphics, x, y)
                        Else
                            pic.Draw(e.Graphics, x, y)
                        End If
                        pic = Nothing
                    ElseIf TypeOf mem Is Model10.CheckBox Then
                        CType(mem, Model10.CheckBox).Draw(e.Graphics, x, y)
                    ElseIf TypeOf mem Is Model10.Button Then
                        Dim btn As Model10.Button = CType(mem, Model10.Button)
                        btn.Draw(e.Graphics, btn.Text, x, y, Me.RightToLeft, fColor)
                        btn = Nothing
                    ElseIf TypeOf mem Is Model10.Sub Then
                        '...
                    ElseIf TypeOf mem Is Model10.Chart Then
                        Dim cht As Model10.Chart = CType(mem, Model10.Chart)
                        cht.DrawChartF(e.Graphics, x, y)
                        cht = Nothing
                    End If
                End If
            End If
        Next : mem = Nothing
    End Sub
    Private Sub FillBody(ByVal newIndex As Integer)
        If clear Then
            clear = False
            content.Clear()

            body.Invalidate()
            If Not band Is Nothing Then band.Invalidate()
            If Not header Is Nothing Then header.Invalidate()
            If Not footer Is Nothing Then footer.Invalidate()
        End If

        If mCurrent.Table.GroupHeader Is Nothing Then
            headerHeight = 0
        Else
            If content.GroupHeader Is Nothing Then
                content.GroupHeader = New Model10.Grouper(mCurrent.Table.GroupHeader, mCurrent.Table.GroupHeader.BackColor)
                FillSection(content.GroupHeader, mCurrent.Table.GroupHeader.Members, mCurrent.DataRow, mCurrent.RecordNumber - 1, mCurrent.RecordCount)
                header.Height = content.GroupHeader.Height
                headerHeight = header.Height
            End If
        End If
        If mCurrent.Table.GroupFooter Is Nothing Then
            footerHeight = 0
        Else
            If content.GroupFooter Is Nothing Then
                content.GroupFooter = New Model10.Grouper(mCurrent.Table.GroupFooter, mCurrent.Table.GroupFooter.BackColor)
                FillSection(content.GroupFooter, mCurrent.Table.GroupFooter.Members, mCurrent.DataRow, mCurrent.RecordNumber - 1, mCurrent.RecordCount)
                footer.Height = content.GroupFooter.Height
                footerHeight = footer.Height
            End If
        End If

        Dim foo As Boolean
        Dim k As Integer = newIndex
        Dim posMem As Model10.Member
        Dim rows As New Model10.RowCollection
        Dim y As Integer

        Dim h As Integer = Height - headerHeight - footerHeight
        '---------------
        If Not hsb Is Nothing Then h -= hsb.Height

        If Not mCurrent.Table.Detail Is Nothing Then
            While k <= totalRowCount - 1 And y < h
                Dim row As Model10.Row = GetRow(k)
                rows.Add(row)

                If k = curPos.RowIndex Then
                    Dim mem As Model10.Member = row.Detail.Members(curPos.MemberName)
                    If Not mem Is Nothing Then
                        If rePos Then
                            If mem.GetType Is GetType(Model10.TextBox) Then
                                SetText(row, CType(mem, Model10.TextBox), GetX, y)
                                foo = True
                            Else
                                box.Text = ""
                                box.Visible = False
                                Me.Focus()
                            End If
                            posMem = mem
                            mem = Nothing
                        Else
                            If mem.GetType Is GetType(Model10.TextBox) Then
                                Dim txt As Model10.TextBox = CType(mem, Model10.TextBox)
                                Dim b As Integer
                                Select Case txt.Border3DStyle
                                    Case Windows.Forms.Border3DStyle.Flat : b = CInt(txt.BorderWidth)
                                    Case Windows.Forms.Border3DStyle.RaisedInner, Windows.Forms.Border3DStyle.RaisedOuter, Windows.Forms.Border3DStyle.SunkenInner, Windows.Forms.Border3DStyle.SunkenOuter : b = 1
                                    Case Windows.Forms.Border3DStyle.Bump, Windows.Forms.Border3DStyle.Etched, Windows.Forms.Border3DStyle.Raised, Windows.Forms.Border3DStyle.Sunken : b = 2
                                End Select
                                box.Top = y + txt.Location.Y + txt.TopMargin + b + body.Top
                                box.Visible = True
                                body.SendToBack()
                                txt = Nothing
                                foo = True
                            Else
                                box.Text = ""
                                box.Visible = False
                            End If
                            mem = Nothing
                        End If
                    End If
                End If

                y += row.Detail.Height
                row = Nothing
                k += 1
            End While
        End If

        If Not foo Then
            box.Visible = False
        End If
        [partial] = h < y
        If rows.Count = 0 Then
            If totalRowCount = 0 Then
                totalHeight = 0
            Else
                totalHeight = 10000
            End If
        Else
            If rows(0).Index = 0 And rows(rows.Count - 1).Index = totalRowCount - 1 Then
                totalHeight = y
            Else
                totalHeight = 10000
            End If
        End If

        content.Rows = rows 'content.Rows should be set before SetPos
        rows = Nothing
        If Not posMem Is Nothing Then
            SetPos(posMem)
            posMem = Nothing
        End If
    End Sub
    Private Sub SetText(ByVal label As Model10.Label, ByVal dataRow As DataRowView, ByVal rowIndex As Integer, ByVal rowCount As Integer)
        If label.Value <> Model10.ValueType.None Then
            Select Case label.Value
                Case Model10.ValueType.DateTime
                    label.Text = Model10.FFormat(Date.Now.ToString, label.Format)
                Case Model10.ValueType.Title
                    label.Text = Model10.FFormat(mCurrent.Table.Presentation.Name, label.Format)
                Case Model10.ValueType.Path
                    label.Text = Model10.FFormat(mCurrent.Table.Presentation.Path, label.Format)
                Case Model10.ValueType.PageCount
                    label.Text = ""
                Case Model10.ValueType.PageNumber
                    label.Text = ""
                Case Model10.ValueType.RecordCount
                    label.Text = Model10.FFormat(rowCount, label.Format)
                Case Model10.ValueType.RecordNumber
                    label.Text = Model10.FFormat(rowIndex + 1, label.Format)
                Case Model10.ValueType.UserId
                    If Not mUser Is Nothing Then label.Text = Model10.FFormat(mUser.Id, label.Format)
                Case Model10.ValueType.UserFullName
                    If Not mUser Is Nothing Then label.Text = Model10.FFormat(mUser.FullName, label.Format)
                Case Model10.ValueType.UserName
                    If Not mUser Is Nothing Then label.Text = Model10.FFormat(mUser.Name, label.Format)
            End Select
        ElseIf label.DataField <> "" Then
            Dim obj As Object
            Try
                If dataRow Is Nothing Then
                    If label.ParentRelation Is Nothing Then
                        obj = mCurrent.Table.DataTable.Columns(label.DataField).DefaultValue
                    Else
                        obj = label.ParentRelation.DataRelation.ParentTable.Columns(label.DataField).DefaultValue
                    End If
                Else
                    If label.ParentRelation Is Nothing Then
                        obj = dataRow(label.DataField)
                    Else
                        obj = dataRow.Row.GetParentRow(label.ParentRelation.DataRelation)(label.DataField)
                    End If
                End If
            Catch ex As Exception
                Try
                    obj = mCurrent.ParaRow(label.DataField)
                Catch exx As Exception
                End Try
            End Try
            If Not IsDBNull(obj) Then label.Text = Model10.FFormat(obj, label.Format)
            obj = Nothing
        ElseIf label.Expression <> "" Then
            Dim obj As Object
            Try
                obj = mCurrent.Table.DataTable.Compute(label.Expression, label.Filter)
                If Not IsDBNull(obj) Then label.Text = Model10.FFormat(obj, label.Format)
                obj = Nothing
            Catch ex As Exception
            End Try
        End If
    End Sub
    Private Sub FillSection(ByVal section As Model10.Section, ByVal members As Model10.MemberCollection, ByVal dataRow As DataRowView, Optional ByVal rowIndex As Integer = 1, Optional ByVal rowCount As Integer = 1, Optional ByVal x As Integer = 0, Optional ByVal y As Integer = 0)
        Dim dif As Integer

        Dim mem As Model10.Member
        For Each mem In members
            'If mem.Visible Then
            Select Case mem.GetType.ToString
                Case "Model10.Line"
                    section.Members.Add(New Model10.Line(CType(mem, Model10.Line)), x, y)
                Case "Model10.Frame"
                    section.Members.Add(New Model10.Frame(CType(mem, Model10.Frame)), x, y)
                Case "Model10.Label"
                    Dim lbl As New Model10.Label(CType(mem, Model10.Label))
                    SetText(lbl, dataRow, rowIndex, rowCount)
                    section.Members.Add(lbl, x, y)
                    If lbl.AutoSize Then Model10.[Global].Measure(lbl, dif, grp, Me.RightToLeft)
                    lbl = Nothing
                Case "Model10.TextBox"
                    Dim txt As New Model10.TextBox(CType(mem, Model10.TextBox))
                    SetText(txt, dataRow, rowIndex, rowCount)
                    section.Members.Add(txt, x, y)
                    If txt.AutoSize Then Model10.[Global].Measure(txt, dif, grp, Me.RightToLeft)
                    txt = Nothing
                    '------------------------
                Case "Model10.PictureBox"
                    Dim pic As New Model10.PictureBox(CType(mem, Model10.PictureBox))
                    If pic.DataField <> "" Then
                        Try
                            Dim obj As Object
                            If dataRow Is Nothing Then
                                obj = mCurrent.Table.DataTable.Columns(pic.DataField).DefaultValue
                            Else
                                If pic.ParentRelation Is Nothing Then
                                    obj = dataRow(pic.DataField)
                                Else
                                    obj = dataRow.Row.GetParentRow(pic.ParentRelation.DataRelation)(pic.DataField)
                                End If
                            End If
                            Select Case TypeName(obj)
                                Case "Byte()" : pic.Image = Model10.[Global].GetImage(CType(obj, Byte()))
                                Case "String" : pic.Image = Image.FromFile(CStr(obj))
                            End Select
                            obj = Nothing
                        Catch ex As Exception
                        End Try
                    End If
                    section.Members.Add(pic, x, y)
                    pic = Nothing
                Case "Model10.CheckBox"
                    Dim chk As New Model10.CheckBox(CType(mem, Model10.CheckBox))
                    Dim nov As Boolean
                    If Not mMultiSelect Is Nothing And rowIndex > mCurrent.DataView.Count - 1 Then
                        If mMultiSelect.DataTable Is mCurrent.Table And mMultiSelect.SelectionField.Trim.ToLower = chk.DataField.Trim.ToLower Then
                            nov = True
                        End If
                    End If
                    If Not nov Then
                        If chk.DataField <> "" Then
                            Try
                                Dim obj As Object
                                If dataRow Is Nothing Then
                                    obj = mCurrent.Table.DataTable.Columns(chk.DataField).DefaultValue
                                Else
                                    If chk.ParentRelation Is Nothing Then
                                        obj = dataRow(chk.DataField)
                                    Else
                                        obj = dataRow.Row.GetParentRow(chk.ParentRelation.DataRelation)(chk.DataField)
                                    End If
                                End If
                                If IsDBNull(obj) Then
                                    chk.Checked = False
                                Else
                                    chk.Checked = CBool(obj)
                                End If
                                obj = Nothing
                            Catch ex As Exception
                            End Try
                        End If
                        section.Members.Add(chk, x, y)
                    End If
                    chk = Nothing
                    '------------------------
                Case "Model10.Select"
                    'If rowIndex <= mCurrent.DataView.Count - 1 Then
                    'If Not mCurrent.DataView(rowIndex).IsNew Then
                    section.Members.Add(New Model10.Select(CType(mem, Model10.Select)), x, y)
                    'End If
                    'End If
                Case "Model10.Edit"
                    If rowIndex > mCurrent.DataView.Count - 1 Then
                        section.Members.Add(New Model10.Edit(CType(mem, Model10.Edit)), x, y)
                    Else
                        If Not mCurrent.DataView(rowIndex).IsEdit Then
                            section.Members.Add(New Model10.Edit(CType(mem, Model10.Edit)), x, y)
                        End If
                    End If
                Case "Model10.Update"
                    If rowIndex <= mCurrent.DataView.Count - 1 Then
                        If mCurrent.DataView(rowIndex).IsEdit Then
                            section.Members.Add(New Model10.Update(CType(mem, Model10.Update)), x, y)
                        End If
                    End If
                Case "Model10.Cancel"
                    If rowIndex <= mCurrent.DataView.Count - 1 Then
                        If mCurrent.DataView(rowIndex).IsEdit Then
                            section.Members.Add(New Model10.Cancel(CType(mem, Model10.Cancel)), x, y)
                        End If
                    End If
                Case "Model10.Delete"
                    If rowIndex <= mCurrent.DataView.Count - 1 Then
                        If Not mCurrent.DataView(rowIndex).IsNew Then
                            section.Members.Add(New Model10.Delete(CType(mem, Model10.Delete)), x, y)
                        End If
                    End If
                Case "Model10.Browse"
                    section.Members.Add(New Model10.Browse(CType(mem, Model10.Browse)), x, y)
                Case "Model10.Computer"
                    'If rowIndex <= mCurrent.DataView.Count - 1 Then
                    section.Members.Add(New Model10.Computer(CType(mem, Model10.Computer)), x, y)
                    'End If
                Case "Model10.Expand"
                    If rowIndex <= mCurrent.DataView.Count - 1 Then
                        If Not mCurrent.DataView(rowIndex).IsNew Then
                            section.Members.Add(New Model10.Expand(CType(mem, Model10.Expand)), x, y)
                        End If
                    End If
                Case "Model10.Next"
                    'If rowIndex <= mCurrent.DataView.Count - 1 Then
                    section.Members.Add(New Model10.Next(CType(mem, Model10.Next)), x, y)
                    'End If
                Case "Model10.MultiSelect"
                    section.Members.Add(New Model10.MultiSelect(CType(mem, Model10.MultiSelect)), x, y)
                Case "Model10.Drilldown"
                    'If rowIndex <= mCurrent.DataView.Count - 1 Then
                    section.Members.Add(New Model10.Drilldown(CType(mem, Model10.Drilldown)), x, y)
                    'End If
                Case "Model10.Lookup"
                    section.Members.Add(New Model10.Lookup(CType(mem, Model10.Lookup)), x, y)
                    '------------------------
                Case "Model10.Sub"
                    If Not dataRow Is Nothing Then
                        Dim sb As Model10.Sub = CType(mem, Model10.Sub)
                        Dim iH As Integer = sb.Location.Y
                        If Not sb.ChildRelation Is Nothing Then
                            If Not sb.ChildRelation.ChildTable.GroupHeader Is Nothing Then
                                FillSection(section, sb.ChildRelation.ChildTable.GroupHeader.Members, dataRow, rowIndex, rowCount, sb.Location.X, iH)
                                iH += sb.ChildRelation.ChildTable.GroupHeader.Height
                            End If
                            '----------------------------------
                            If Not mCurrent.Relation Is Nothing Then
                                Model10.[Global].FillChildData(mCurrent.Relation.ParentTable, Nothing, mCurrent.DataRow, mRelation)
                            End If

                            Dim dr As DataRowView, i As Integer
                            Dim dv As DataView = dataRow.CreateChildView(sb.ChildRelation.DataRelation)
                            For Each dr In dv
                                If mLayout Is Nothing Then
                                    Try
                                        Model10.[Global].FillChildData(sb.ChildRelation.ChildTable, Nothing, dr, mRelation)
                                    Catch ex As Exception
                                    End Try
                                End If

                                If Not sb.ChildRelation.ChildTable.Detail Is Nothing Then
                                    FillSection(section, sb.ChildRelation.ChildTable.Detail.Members, dr, i + 1, dv.Count, sb.Location.X, iH)
                                    iH += sb.ChildRelation.ChildTable.Detail.Height
                                End If
                                i += 1
                            Next : dr = Nothing
                            dv = Nothing
                            '----------------------------------
                            If Not sb.ChildRelation.ChildTable.GroupFooter Is Nothing Then
                                FillSection(section, sb.ChildRelation.ChildTable.GroupFooter.Members, dataRow, rowIndex, rowCount, sb.Location.X, iH)
                                iH += sb.ChildRelation.ChildTable.GroupFooter.Height
                            End If
                        End If
                        sb = Nothing
                    End If
                Case "Model10.Chart"
                    Dim cht As New Model10.Chart(CType(mem, Model10.Chart))
                    section.Members.Add(cht, x, y)
                    cht = Nothing
            End Select
            'End If
        Next : mem = Nothing
        For Each mem In section.Members
            If mem.Visible Then
                If dif > 0 Then
                    Dim d As Integer
                    If TypeOf mem Is Model10.Label Then d = CType(mem, Model10.Label).Difference

                    If mem.Anchor = Model10.AnchorMode.TopAndBottom Then
                        mem.Size = New Drawing.Size(mem.Size.Width, mem.Size.Height + dif - d)
                    ElseIf mem.Anchor = Model10.AnchorMode.Bottom Then
                        mem.Location = New Drawing.Point(mem.Location.X, mem.Location.Y + dif - d)
                    ElseIf mem.Anchor = Model10.AnchorMode.None Then
                        mem.Location = New Drawing.Point(mem.Location.X, mem.Location.Y + (dif - d) \ 2)
                    End If
                End If
                If Not dataRow Is Nothing Then
                    If TypeOf mem Is Model10.Chart Then
                        CType(mem, Model10.Chart).FillChart(dataRow, False)
                    End If
                End If
            End If
        Next : mem = Nothing
        section.Height += dif
    End Sub
    Private Sub FitBox()
        Dim mem As Model10.Member = GetMem(curPos)
        If Not mem Is Nothing Then
            If mem.GetType Is GetType(Model10.TextBox) Then
                Dim txt As Model10.TextBox = CType(mem, Model10.TextBox)
                Dim x As Integer = GetX()
                Dim b As Integer
                Select Case txt.Border3DStyle
                    Case Windows.Forms.Border3DStyle.Flat : b = CInt(txt.BorderWidth)
                    Case Windows.Forms.Border3DStyle.RaisedInner, Windows.Forms.Border3DStyle.RaisedOuter, Windows.Forms.Border3DStyle.SunkenInner, Windows.Forms.Border3DStyle.SunkenOuter : b = 1
                    Case Windows.Forms.Border3DStyle.Bump, Windows.Forms.Border3DStyle.Etched, Windows.Forms.Border3DStyle.Raised, Windows.Forms.Border3DStyle.Sunken : b = 2
                End Select
                box.Left = x + txt.Location.X + txt.LeftMargin + b + body.Left
                txt = Nothing
            End If
        End If
        mem = Nothing
    End Sub
    Private Sub Backward()
        Dim pos As Avand.Position

        Dim memAr As Model10.Member() = GetRow(curPos.RowIndex).Detail.GetMembers
        If memAr Is Nothing Then
            pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
        Else
            Dim idx As Integer
            If curPos.MemberName = "" Then idx = 1 Else idx = IndexOf(memAr, curPos.MemberName)
            If idx - 1 < 0 Then
                If curPos.RowIndex - 1 < 0 Then
                    pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                    'Me.Parent.SelectNextControl(Me, False, True, True, True)
                Else
                    memAr = GetRow(curPos.RowIndex - 1).Detail.GetMembers
                    If memAr Is Nothing Then
                        pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                    Else
                        pos.RowIndex = curPos.RowIndex - 1 : pos.MemberName = memAr(UBound(memAr)).Name
                    End If
                End If
            Else
                pos.RowIndex = curPos.RowIndex : pos.MemberName = memAr(idx - 1).Name
            End If
        End If
        memAr = Nothing

        Final(pos)
    End Sub
    Private Sub Forward()
        Dim pos As Avand.Position

        Dim memAr As Model10.Member() = GetRow(curPos.RowIndex).Detail.GetMembers
        If memAr Is Nothing Then
            pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
        Else
            Dim idx As Integer
            If curPos.MemberName = "" Then idx = -1 Else idx = IndexOf(memAr, curPos.MemberName)
            If idx + 1 > UBound(memAr) Then
                If curPos.RowIndex + 1 > totalRowCount - 1 Then
                    pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                    'Me.Parent.SelectNextControl(Me, True, True, True, True)
                Else
                    memAr = GetRow(curPos.RowIndex + 1).Detail.GetMembers
                    If memAr Is Nothing Then
                        pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                    Else
                        pos.RowIndex = curPos.RowIndex + 1 : pos.MemberName = memAr(0).Name
                    End If
                End If
            Else
                pos.RowIndex = curPos.RowIndex : pos.MemberName = memAr(idx + 1).Name
            End If
        End If
        memAr = Nothing

        Final(pos)
    End Sub
    Private Sub KeyDowning(ByVal keyCode As System.Windows.Forms.Keys, ByVal shift As Boolean)
        If keyCode = Keys.Back Then OnRequestBack(New EventArgs)
        If totalRowCount > 0 And Not mCurrent.Table.Detail Is Nothing Then
            If shift Then
                Select Case keyCode
                    Case Keys.Tab
                        Dim pos As Avand.Position

                        Dim memAr As Model10.Member() = GetRow(curPos.RowIndex).Detail.GetMembers
                        If memAr Is Nothing Then
                            pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                        Else
                            Dim idx As Integer = IndexOf(memAr, curPos.MemberName)
                            If idx - 1 < 0 Then
                                If curPos.RowIndex - 1 < 0 Then
                                    pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                                    Me.Parent.SelectNextControl(Me, False, True, True, True)
                                Else
                                    memAr = GetRow(curPos.RowIndex - 1).Detail.GetMembers
                                    pos.RowIndex = curPos.RowIndex - 1 : pos.MemberName = memAr(UBound(memAr)).Name
                                End If
                            Else
                                pos.RowIndex = curPos.RowIndex : pos.MemberName = memAr(idx - 1).Name
                            End If
                        End If
                        memAr = Nothing

                        Final(pos)
                End Select
            Else
                Select Case keyCode
                    Case Keys.Tab
                        Dim pos As Avand.Position

                        Dim memAr As Model10.Member() = GetRow(curPos.RowIndex).Detail.GetMembers
                        If memAr Is Nothing Then
                            pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                        Else
                            Dim idx As Integer = IndexOf(memAr, curPos.MemberName)
                            If idx + 1 > UBound(memAr) Then
                                If curPos.RowIndex + 1 > totalRowCount - 1 Then
                                    pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                                    Me.Parent.SelectNextControl(Me, True, True, True, True)
                                Else
                                    memAr = GetRow(curPos.RowIndex + 1).Detail.GetMembers
                                    pos.RowIndex = curPos.RowIndex + 1 : pos.MemberName = memAr(0).Name
                                End If
                            Else
                                pos.RowIndex = curPos.RowIndex : pos.MemberName = memAr(idx + 1).Name
                            End If
                        End If
                        memAr = Nothing

                        Final(pos)
                    Case Keys.Left
                        If Me.RightToLeft = RightToLeft.Yes Then Forward() Else Backward()
                    Case Keys.Right
                        If Me.RightToLeft = RightToLeft.Yes Then Backward() Else Forward()
                    Case Keys.Up
                        Dim pos As Avand.Position
                        If curPos.RowIndex - 1 < 0 Then
                            pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                        Else
                            pos.RowIndex = curPos.RowIndex - 1 : pos.MemberName = curPos.MemberName
                        End If
                        Final(pos)
                    Case Keys.Down
                        Dim pos As Avand.Position
                        If curPos.RowIndex + 1 > totalRowCount - 1 Then
                            pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                        Else
                            pos.RowIndex = curPos.RowIndex + 1 : pos.MemberName = curPos.MemberName
                        End If
                        Final(pos)
                    Case Keys.PageUp
                        Dim h As Integer = Height - headerHeight - footerHeight
                        '---------------
                        If Not hsb Is Nothing Then h -= hsb.Height

                        Dim k As Integer = curPos.RowIndex
                        Dim y As Integer

                        While k >= 0 And y < h
                            Dim row As Model10.Row = GetRow(k)
                            If y + row.Detail.Height > h Then Exit While
                            y += row.Detail.Height
                            row = Nothing
                            k -= 1
                        End While

                        Dim pos As Avand.Position
                        If k + 1 < curPos.RowIndex Then
                            pos.RowIndex = k + 1 : pos.MemberName = curPos.MemberName
                        Else
                            'Keys.Up
                            If curPos.RowIndex - 1 < 0 Then
                                pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                            Else
                                pos.RowIndex = curPos.RowIndex - 1 : pos.MemberName = curPos.MemberName
                            End If
                        End If
                        Final(pos)
                    Case Keys.PageDown
                        Dim h As Integer = Height - headerHeight - footerHeight
                        '---------------
                        If Not hsb Is Nothing Then h -= hsb.Height

                        Dim k As Integer = curPos.RowIndex
                        Dim y As Integer

                        While k <= totalRowCount - 1 And y < h
                            Dim row As Model10.Row = GetRow(k)
                            If y + row.Detail.Height > h Then Exit While
                            y += row.Detail.Height
                            row = Nothing
                            k += 1
                        End While

                        Dim pos As Avand.Position
                        If k - 1 > curPos.RowIndex Then
                            pos.RowIndex = k - 1 : pos.MemberName = curPos.MemberName
                        Else
                            'Keys.Down
                            If curPos.RowIndex + 1 > totalRowCount - 1 Then
                                pos.RowIndex = curPos.RowIndex : pos.MemberName = curPos.MemberName
                            Else
                                pos.RowIndex = curPos.RowIndex + 1 : pos.MemberName = curPos.MemberName
                            End If
                        End If
                        Final(pos)
                    Case Keys.Escape
                        If curPos.RowIndex <= mCurrent.DataView.Count - 1 And mCurrent.DataView.Count > 0 Then
                            Canceling(mCurrent.RowData)
                        End If
                    Case Keys.Space
                        Dim mem As Model10.Member = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
                        If Not mem Is Nothing Then
                            If TypeOf mem Is Model10.Button Then
                                If Not space Then
                                    Dim btn As Model10.Button = CType(mem, Model10.Button)
                                    space = True
                                    SetRow(curPos)
                                    btn = Nothing
                                End If
                            End If
                        End If
                        mem = Nothing
                    Case Keys.Delete
                        Deleting()
                    Case Keys.Enter
                        Dim mem As Model10.Member = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
                        If mem Is Nothing Then
                            body_DoubleClick(Nothing, Nothing)
                        Else
                            If TypeOf mem Is Model10.Button Then
                                If Not inter Then
                                    Dim btn As Model10.Button = CType(mem, Model10.Button)
                                    inter = True
                                    Press(btn)
                                    SetRow(curPos)
                                    btn = Nothing
                                End If
                            End If
                        End If
                        mem = Nothing
                End Select
            End If
            If curPos.RowIndex <> lastPos Then
                If curPos.RowIndex = 0 Or curPos.RowIndex = totalRowCount - 1 Then
                    OnRowChangeCommitted(New EventArgs)
                End If
            End If
        End If
    End Sub
    Private Sub KeyUpping(ByVal keyCode As System.Windows.Forms.Keys)
        If totalRowCount > 0 Then
            Select Case keyCode
                Case Keys.Space
                    space = False

                    Dim mem As Model10.Member
                    Dim x As Integer = GetX()
                    Dim y As Integer

                    Dim row As Model10.Row
                    For Each row In content.Rows
                        If row.Index = curPos.RowIndex Then
                            mem = row.Detail.Members(curPos.MemberName)
                            If Not mem Is Nothing Then
                                If TypeOf mem Is Model10.Button Then
                                    body.Invalidate(New Rectangle(x + mem.Location.X, y + mem.Location.Y, mem.Size.Width, mem.Size.Height))
                                End If
                            End If
                            mem = Nothing
                            Exit For
                        End If
                        y += row.Detail.Height
                    Next : row = Nothing

                    mem = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
                    If mem Is Nothing Then
                        body_DoubleClick(Nothing, Nothing)
                    Else
                        If mem.GetType Is GetType(Model10.CheckBox) Then
                            Check(CType(mem, Model10.CheckBox))
                        ElseIf TypeOf mem Is Model10.Button Then
                            SetRow(curPos)
                            Press(CType(mem, Model10.Button))
                        End If
                    End If
                    mem = Nothing
                Case Keys.Enter
                    inter = False
            End Select
            If curPos.RowIndex <> lastPos Then
                OnRowChangeCommitted(New EventArgs)
            End If
        End If
    End Sub
    Private Sub MouseWheeling(ByVal e As MouseEventArgs)
        If MouseButtons = MouseButtons.None Then
            If Not vsb Is Nothing Then
                Dim i As Integer
                If e.Delta > 0 Then i = vsb.Value - 1
                If e.Delta < 0 Then i = vsb.Value + 1
                If i < vsb.Minimum Then i = vsb.Minimum
                If i > vsb.Maximum - vsb.LargeChange + 1 Then i = vsb.Maximum - vsb.LargeChange + 1
                vsb.Value = i
            End If
        End If
    End Sub
    Private Sub Mousing()
        Dim p As Point = body.PointToClient(body.MousePosition)
        body_MouseMove(Me, New MouseEventArgs(MouseButtons.None, 0, p.X, p.Y, 0))
    End Sub
    Private Sub Press(ByVal button As Model10.Button)
        Select Case button.GetType.ToString
            Case "Model10.Select"
                If curPos.RowIndex > mCurrent.DataView.Count - 1 Then Editing()
                If Final(curPos, True) Then OnRowSelect(New EventArgs)
            Case "Model10.Edit" : Editing()
            Case "Model10.Update" : Updating()
            Case "Model10.Cancel" : Canceling(mCurrent.RowData)
            Case "Model10.Delete" : Deleting()
            Case "Model10.Browse"
                Dim dialogRes As DialogResult
                Dim wasEdit, isNew As Boolean
                If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
                    wasEdit = mCurrent.RowData.IsEdit
                Else
                    isNew = True
                End If

                Dim brs As Model10.Browse = CType(button, Model10.Browse)
                If brs.ShowEditor Then
                    Static frm As Avand.Browse
                    If frm Is Nothing Then frm = New Avand.Browse

                    Application.DoEvents()
                    Cursor.Current = Cursors.WaitCursor
                    '----------------------------------
                    frm.Browse = brs
                    frm.Current = mCurrent
                    frm.ReadOnly = mCurrent.Table.UpdateCommand Is Nothing
                    frm.Fill()
                    inter = False
                    dialogRes = frm.ShowDialog(Me)
                    '----------------------------------
                    Cursor.Current = Cursors.Default
                Else
                    If brs.PathField.Trim <> "" Then
                        Try
                            fMain.OpenFileDialog1.InitialDirectory = CStr(mCurrent.RowData(brs.PathField.Trim))
                        Catch ex As Exception
                        End Try
                    End If
                    fMain.OpenFileDialog1.Filter = brs.Filter
                    inter = False
                    If fMain.OpenFileDialog1.ShowDialog(Me) = DialogResult.OK Then
                        Dim isEdit As Boolean

                        If mCurrent.RowData Is Nothing Then
                            mCurrent.RowData = mCurrent.DataView.AddNew
                        Else
                            If mCurrent.RowData.IsEdit Then
                                isEdit = True
                            Else
                                mCurrent.RowData.BeginEdit()
                            End If
                        End If

                        Application.DoEvents()
                        Cursor.Current = Cursors.WaitCursor
                        '----------------------------------
                        Try
                            Dim fs As New IO.FileStream(fMain.OpenFileDialog1.FileName, IO.FileMode.Open, IO.FileAccess.Read)
                            Dim b(CInt(fs.Length) - 1) As Byte
                            fs.Read(b, 0, b.Length)
                            fs.Close() : fs = Nothing
                            If brs.PathField.Trim <> "" Then
                                Try
                                    Select Case brs.PathType
                                        Case Model10.PathType.Complete : mCurrent.RowData(brs.PathField) = fMain.OpenFileDialog1.FileName
                                        Case Model10.PathType.DirectoryName : mCurrent.RowData(brs.PathField) = IO.Path.GetDirectoryName(fMain.OpenFileDialog1.FileName)
                                        Case Model10.PathType.Extension : mCurrent.RowData(brs.PathField) = IO.Path.GetExtension(fMain.OpenFileDialog1.FileName)
                                        Case Model10.PathType.FileName : mCurrent.RowData(brs.PathField) = IO.Path.GetFileName(fMain.OpenFileDialog1.FileName)
                                        Case Model10.PathType.FileNameWithoutExtension : mCurrent.RowData(brs.PathField) = IO.Path.GetFileNameWithoutExtension(fMain.OpenFileDialog1.FileName)
                                        Case Model10.PathType.FullPath : mCurrent.RowData(brs.PathField) = IO.Path.GetFullPath(fMain.OpenFileDialog1.FileName)
                                        Case Model10.PathType.PathRoot : mCurrent.RowData(brs.PathField) = IO.Path.GetPathRoot(fMain.OpenFileDialog1.FileName)
                                    End Select
                                Catch ex As Exception
                                End Try
                            End If
                            If brs.ContentField.Trim <> "" Then
                                Try
                                    mCurrent.RowData(brs.ContentField.Trim) = b
                                Catch ex As Exception
                                End Try
                            End If
                            b = Nothing
                        Catch ex As Exception
                            MsgBox(ex.Message)
                            If Not isEdit Then mCurrent.RowData.CancelEdit()
                        End Try
                        dialogRes = DialogResult.OK
                        '----------------------------------
                        Cursor.Current = Cursors.Default
                    End If
                End If
                brs = Nothing

                If dialogRes = DialogResult.OK Then
                    If Not mCurrent.Table.UpdateCommand Is Nothing Then
                        '-------------------
                        If isNew Then
                            ReRow()
                            totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                            OnResize(New EventArgs)
                        Else
                            ReRow()
                            OnResize(New EventArgs)
                        End If
                        SetRow(curPos)
                        '-------------------
                        Dim y As Integer

                        Dim row As Model10.Row
                        For Each row In content.Rows
                            If row.Index = curPos.RowIndex Then
                                If isNew Then
                                    body.Invalidate(New Rectangle(0, y, body.Width, body.Height - y))
                                    If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, band.Height - y))
                                Else
                                    body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                                    If Not wasEdit Then
                                        If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, 16))
                                    End If
                                End If
                                Exit For
                            End If
                            y += row.Detail.Height
                        Next : row = Nothing
                        '-------------------
                        If Not wasEdit Then OnRowEdit(New EventArgs)
                    End If
                End If
            Case "Model10.Computer"
                If curPos.RowIndex > mCurrent.DataView.Count - 1 Then Editing()
                Dim computer As Model10.Computer = CType(button, Model10.Computer)
                If Not computer.Compute Is Nothing Then
                    ReadLabels(GetRow(curPos.RowIndex))
                    Select Case computer.Compute.Action
                        Case Model10.ActionMode.Function
                            Dim dialogResult As DialogResult = dialogResult.OK
                            If computer.Compute.PromptMessage.Trim <> "" Then
                                dialogResult = MessageBox.Show(Me, computer.Compute.PromptMessage.Trim, computer.Compute.Name, MessageBoxButtons.OKCancel)
                            End If
                            If dialogResult = dialogResult.OK Then
                                Application.DoEvents()
                                Cursor.Current = Cursors.WaitCursor
                                '----------------------------------
                                Dim wasEdit, isNew As Boolean
                                Dim dr As DataRowView
                                If mCurrent.RowData Is Nothing Then
                                    dr = mCurrent.DataView.AddNew
                                    mCurrent.RowData = dr '  
                                    isNew = True
                                Else
                                    dr = mCurrent.RowData
                                    wasEdit = dr.IsEdit
                                    If Not wasEdit Then dr.BeginEdit()
                                End If
                                Try
                                    Dim prm As OleDb.OleDbParameter
                                    For Each prm In computer.Compute.OleDbCommand.Parameters
                                        If prm.Direction = ParameterDirection.Input Or prm.Direction = ParameterDirection.InputOutput Then
                                            If Not prm.SourceColumn Is Nothing Then
                                                If mCurrent.RowData.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                                                    prm.Value = mCurrent.RowData(prm.SourceColumn)
                                                Else
                                                    If Not mCurrent.ParaRow Is Nothing Then
                                                        If mCurrent.ParaRow.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                                                            prm.Value = mCurrent.ParaRow(prm.SourceColumn)
                                                        End If
                                                    End If
                                                End If
                                            End If
                                        End If
                                    Next : prm = Nothing
                                    computer.Compute.OleDbCommand.ExecuteNonQuery()
                                    For Each prm In computer.Compute.OleDbCommand.Parameters
                                        If prm.Direction = ParameterDirection.Output Or prm.Direction = ParameterDirection.InputOutput Then
                                            If mCurrent.RowData.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                                                dr(prm.SourceColumn) = prm.Value
                                            End If
                                        End If
                                    Next : prm = Nothing
                                    mCurrent.RowData.Row.AcceptChanges()
                                    '-------------------

                                    '    
                                    '----------
                                    clear = True
                                    totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                                    If curPos.RowIndex > totalRowCount - 1 Then curPos.RowIndex = totalRowCount - 1
                                    If curPos.RowIndex > mCurrent.DataView.Count - 1 Then
                                        mCurrent.RowData = Nothing
                                    Else
                                        mCurrent.RowData = mCurrent.DataView(curPos.RowIndex)
                                    End If
                                    ReRow()
                                    rePos = True : mTextMode = False
                                    If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                                    SetRow(curPos)
                                    OnResize(New EventArgs)
                                    '----------

                                    'If isNew Then
                                    '    totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                                    '    ReRow()
                                    '    If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                                    '    OnResize(New EventArgs)
                                    'Else
                                    '    'If Not wasEdit Then
                                    '    ReRow()
                                    '    OnResize(New EventArgs)
                                    '    'End If
                                    'End If
                                    SetRow(curPos)
                                    '-------------------
                                    Dim y As Integer

                                    Dim row As Model10.Row
                                    For Each row In content.Rows
                                        If row.Index = curPos.RowIndex Then
                                            If isNew Then
                                                body.Invalidate(New Rectangle(0, y, body.Width, body.Height - y))
                                                If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, band.Height - y))
                                            Else
                                                If wasEdit Then
                                                    body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                                                Else
                                                    body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                                                    If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, 16))
                                                End If
                                            End If
                                            Exit For
                                        End If
                                        y += row.Detail.Height
                                    Next : row = Nothing
                                    '-------------------
                                    If Not wasEdit Then OnRowEdit(New EventArgs)
                                Catch ex As Exception
                                    If Not wasEdit Then dr.CancelEdit()
                                    SetRow(curPos)
                                    MsgBox(ex.Message)
                                End Try
                                dr = Nothing
                                '----------------------------------
                                Cursor.Current = Cursors.Default
                            End If
                        Case Else
                            Dim dialogResult As DialogResult = dialogResult.OK
                            If computer.Compute.PromptMessage.Trim <> "" Then
                                dialogResult = MessageBox.Show(Me, computer.Compute.PromptMessage.Trim, computer.Compute.Name, MessageBoxButtons.OKCancel)
                            End If
                            If dialogResult = dialogResult.OK Then
                                If Final(curPos, True) Then
                                    Application.DoEvents()
                                    Cursor.Current = Cursors.WaitCursor
                                    '----------------------------------
                                    Try
                                        Dim prm As OleDb.OleDbParameter
                                        For Each prm In computer.Compute.OleDbCommand.Parameters
                                            If prm.Direction = ParameterDirection.Input Or prm.Direction = ParameterDirection.InputOutput Then
                                                If Not prm.SourceColumn Is Nothing Then
                                                    If mCurrent.RowData.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                                                        prm.Value = mCurrent.RowData(prm.SourceColumn)
                                                    Else
                                                        If Not mCurrent.ParaRow Is Nothing Then
                                                            If mCurrent.ParaRow.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                                                                prm.Value = mCurrent.ParaRow(prm.SourceColumn)
                                                            End If
                                                        End If
                                                    End If
                                                End If
                                            End If
                                        Next : prm = Nothing
                                        If Not computer.Compute.Prepared Then
                                            computer.Compute.OleDbCommand.Prepare()
                                            computer.Compute.Prepared = True
                                        End If
                                        Try
                                            Dim i As Integer = computer.Compute.OleDbCommand.ExecuteNonQuery()
                                            Dim dr As DataRowView = mCurrent.RowData
                                            For Each prm In computer.Compute.OleDbCommand.Parameters
                                                If prm.Direction = ParameterDirection.Output Or prm.Direction = ParameterDirection.InputOutput Then
                                                    If mCurrent.RowData.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                                                        If mCurrent.Table.DataTable.Columns(prm.SourceColumn).ReadOnly Then
                                                            mCurrent.Table.DataTable.Columns(prm.SourceColumn).ReadOnly = False
                                                            Try
                                                                dr(prm.SourceColumn) = prm.Value
                                                            Catch ex As Exception
                                                                Throw ex
                                                            Finally
                                                                mCurrent.Table.DataTable.Columns(prm.SourceColumn).ReadOnly = True
                                                            End Try
                                                        Else
                                                            Try
                                                                dr(prm.SourceColumn) = prm.Value
                                                            Catch ex As Exception
                                                                Throw ex
                                                            End Try
                                                        End If
                                                    End If
                                                End If
                                            Next : prm = Nothing
                                            mCurrent.RowData.Row.AcceptChanges()

                                            '    
                                            '----------
                                            WriteMessage(mCurrent.RowData, "") '"Result: " & i & " record(s) was affected."

                                            clear = True
                                            totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                                            If curPos.RowIndex > totalRowCount - 1 Then curPos.RowIndex = totalRowCount - 1
                                            If curPos.RowIndex > mCurrent.DataView.Count - 1 Then
                                                mCurrent.RowData = Nothing
                                            Else
                                                mCurrent.RowData = mCurrent.DataView(curPos.RowIndex)
                                            End If
                                            ReRow()
                                            rePos = True : mTextMode = False
                                            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                                            SetRow(curPos)
                                            OnResize(New EventArgs)
                                            '----------

                                            'If computer.Compute.Remove Then
                                            '    mCurrent.RowData.DataView.Table.Rows.Remove(mCurrent.RowData.Row)

                                            '    clear = True
                                            '    totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                                            '    If curPos.RowIndex > mCurrent.DataView.Count - 1 Then
                                            '        If mCurrent.Table.InsertCommand Is Nothing Then
                                            '            curPos.RowIndex = mCurrent.DataView.Count - 1
                                            '        Else
                                            '            If mCurrent.DataView.Count = 0 Then
                                            '                curPos.RowIndex = mCurrent.DataView.Count
                                            '            Else
                                            '                curPos.RowIndex = mCurrent.DataView.Count - 1
                                            '            End If
                                            '        End If
                                            '    End If
                                            '    ReRow()
                                            '    rePos = True : mTextMode = False
                                            '    If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                                            '    OnResize(New EventArgs)
                                            '    SetRow(curPos, True)
                                            'Else
                                            '    WriteMessage(mCurrent.RowData, "") '"Result: " & i & " record(s) was affected."

                                            '    ReRow()
                                            '    clear = True
                                            '    OnResize(New EventArgs)
                                            '    rePos = True : mTextMode = False
                                            '    If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                                            '    SetRow(curPos)
                                            '    OnResize(New EventArgs)
                                            'End If
                                            'MsgBox("Done!")
                                        Catch ex As Exception
                                            WriteMessage(mCurrent.RowData, ex.Message)
                                            MsgBox(ex.Message)

                                            clear = True
                                            rePos = True : mTextMode = False
                                            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                                            SetRow(curPos)
                                            OnResize(New EventArgs)
                                        End Try
                                    Catch ex As Exception
                                        MsgBox(ex.Message)
                                    End Try
                                    '----------------------------------
                                    Cursor.Current = Cursors.Default
                                End If
                            End If
                            If computer.Compute.Presentation.Trim <> "" Then
                                Application.DoEvents()
                                Cursor.Current = Cursors.WaitCursor
                                '----------------------------------
                                Try
                                    Dim no As Boolean
                                    If computer.Compute.Form Is Nothing Then
                                        no = True
                                    Else
                                        no = Not computer.Compute.Form.Visible
                                    End If
                                    If no Then
                                        Dim obj As Object
                                        If IsNumeric(computer.Compute.Presentation.Trim) Then
                                            Try
                                                mOleDbConnection.Open()
                                                obj = Model10.Database.BinNodeDeserialize(CInt(computer.Compute.Presentation.Trim), mOleDbConnection)
                                            Catch ex As Exception
                                            Finally
                                                mOleDbConnection.Close()
                                            End Try
                                        Else
                                            obj = Model10.Database.BinFileDeserialize(computer.Compute.Presentation.Trim)
                                        End If
                                        If TypeOf obj Is Model10.Presentation Then
                                            Dim prs As Model10.Presentation = CType(obj, Model10.Presentation)
                                            If Not prs.StartupTable Is Nothing Then SetParam(prs.StartupTable, mCurrent.RowData, mCurrent.ParaRow)
                                            computer.Compute.Form = OpenPresentation(prs, mUser, Me.FindForm, mOleDbConnection, mConnections)
                                            prs = Nothing
                                        End If
                                    Else
                                        If TypeOf computer.Compute.Form Is Avand.FormView Then
                                            Dim fw As Avand.FormView = CType(computer.Compute.Form, Avand.FormView)
                                            SetParam(fw.Grid1.Current.Table.Presentation.StartupTable, mCurrent.RowData, mCurrent.ParaRow)
                                            fw.miViewRefresh.PerformClick()
                                            fw.Show()
                                            fw.Activate()
                                            fw = Nothing
                                        End If
                                    End If
                                Catch ex As Exception
                                End Try
                                '----------------------------------
                                Cursor.Current = Cursors.Default
                            End If
                    End Select
                End If
                computer = Nothing
            Case "Model10.Expand"
                If curPos.RowIndex > mCurrent.DataView.Count - 1 Then Editing()
                If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
                    If Final(curPos, True) Then
                        Dim exp As Model10.Expand = CType(button, Model10.Expand)
                        If Not exp.ParentRelation Is Nothing And Not exp.ChildRelation Is Nothing Then
                            Application.DoEvents()
                            Cursor.Current = Cursors.WaitCursor
                            '----------------------------------
                            Try
                                Dim dr As DataRow = mCurrent.RowData.Row.GetParentRow(exp.ChildRelation.DataRelation)

                                Dim d As DataRowView, l As Integer
                                For Each d In exp.ChildRelation.DataRelation.ParentTable.DefaultView 'mCurrent.DataRow.DataView
                                    If d.Row Is dr Then
                                        Model10.[Global].FillChildData(exp.ChildRelation.ParentTable, mCurrent.RowData, d, Nothing)
                                        OnRowDrilldown(New Model10.DrilldownEventArgs(New Model10.Current(exp.ParentRelation.ChildTable, exp.ParentRelation, d.CreateChildView(exp.ParentRelation.DataRelation), d, mCurrent.ParaRow, mCurrent.DataView.Count, curPos.RowIndex + 1)))
                                        Exit For
                                    End If
                                    l += 1
                                Next : d = Nothing

                                dr = Nothing
                            Catch ex As Exception
                                MsgBox(ex.Message)
                            End Try
                            '----------------------------------
                            Cursor.Current = Cursors.Default
                        End If
                        exp = Nothing
                    End If
                End If
            Case "Model10.Next"
                If curPos.RowIndex > mCurrent.DataView.Count - 1 Then Editing()
                If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
                    If Final(curPos, True) Then
                        Dim nxt As Model10.Next = CType(button, Model10.Next)
                        If Not nxt.Table Is Nothing Then
                            ReadLabels(GetRow(curPos.RowIndex))
                            Dim dv As DataView = mCurrent.Table.Presentation.DataViewManager.CreateDataView(nxt.Table.DataTable)
                            'If nxt.Table.SelectCommand Is Nothing And dv.Count = 1 And nxt.Table.ChildRelations.Count = 1 Then
                            '    Application.DoEvents()
                            '    Cursor.Current = Cursors.WaitCursor
                            '    '----------------------------------
                            '    Try
                            '        Model10.Global.ClearData(nxt.Table)
                            '        If Not nxt.Table.Field Is Nothing Then dv(0)(nxt.Table.Field) = False ' 
                            '        Model10.Global.FillChildData(nxt.Table, mCurrent.RowData, dv(0), Nothing)
                            '    Catch ex As Exception
                            '        MsgBox(ex.Message)
                            '    End Try
                            '    '----------------------------------
                            '    Cursor.Current = Cursors.Default

                            '    OnRowDrilldown(New Model10.DrilldownEventArgs(New Model10.Current( _
                            '        nxt.Table.ChildRelations(0).ChildTable, _
                            '        nxt.Table.ChildRelations(0), _
                            '        dv(0).CreateChildView(nxt.Table.ChildRelations(0).DataRelation), _
                            '        dv(0), _
                            '        mCurrent.RowData, _
                            '        1, _
                            '        1 _
                            '    )))
                            'Else
                            If mLayout Is Nothing Then
                                Application.DoEvents()
                                Cursor.Current = Cursors.WaitCursor
                                '----------------------------------
                                Try
                                    Model10.[Global].ClearData(nxt.Table, mCurrent.RowData, Nothing)
                                    Model10.[Global].FillData(nxt.Table, mCurrent.RowData, Nothing)
                                Catch ex As Exception
                                    MsgBox(ex.Message)
                                End Try
                                '----------------------------------
                                Cursor.Current = Cursors.Default
                            End If

                            OnRowDrilldown(New Model10.DrilldownEventArgs(New Model10.Current( _
                                 nxt.Table, _
                                 Nothing, _
                                 dv, _
                                 mCurrent.RowData, _
                                 mCurrent.RowData, _
                                 mCurrent.DataView.Count, _
                                 curPos.RowIndex + 1 _
                             )))
                            'End If
                            dv = Nothing
                        End If
                        nxt = Nothing
                    End If
                End If
            Case "Model10.MultiSelect"
                If Final(curPos, True) Then
                    Dim ms As Model10.MultiSelect = CType(button, Model10.MultiSelect)
                    If ms.DataTable Is Nothing Then Exit Sub
                    Dim stuTable As Model10.Table
                    If ms.StartupTable Is Nothing Then
                        stuTable = ms.DataTable
                    Else
                        stuTable = ms.StartupTable
                    End If
                    Dim frm As New Avand.FormView

                    Application.DoEvents()
                    Cursor.Current = Cursors.WaitCursor
                    '----------------------------------
                    '-----------------Special
                    'If ms.DataTable.Name = "Alternative" Then
                    '    ms.DataTable.DataTable.DataSet.EnforceConstraints = False
                    '    ms.DataTable.DataTable.Clear()
                    '    ms.DataTable.DataTable.DataSet.EnforceConstraints = True
                    '    ms.DataTable.Filled = False
                    'End If
                    '-----------------Special
                    frm.StartPosition = FormStartPosition.CenterParent
                    frm.Size = stuTable.Size
                    frm.Grid1.User = mUser
                    frm.Grid1.Layouting = mLayout
                    frm.Navigator1.Chain = New ArrayList
                    'Model10.Global.ClearData(stuTable)
                    Try
                        Model10.[Global].FillData(stuTable, mCurrent.RowData, Nothing)
                    Catch ex As Exception
                        MsgBox(ex.Message)
                    End Try
                    frm.Grid1.Current = New Model10.Current(stuTable, Nothing, stuTable.Presentation.DataViewManager.CreateDataView(stuTable.DataTable), Nothing, mCurrent.RowData, 1, 1)
                    frm.Navigator1.Chain.Add(frm.Grid1.Current)

                    frm.Grid1.ParentFormView = CType(Me.FindForm, Avand.FormView)
                    frm.Grid1.MultiSelect = ms
                    frm.Fill(frm.Navigator1.Chain.Count = 1)

                    Dim wasEdit, isNew As Boolean
                    If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
                        wasEdit = mCurrent.RowData.IsEdit
                    Else
                        isNew = True
                    End If

                    inter = False
                    If frm.ShowDialog(Me.FindForm) = DialogResult.OK Then
                        Dim mem As Model10.Member = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
                        If Not mem Is Nothing Then
                            If mem.GetType Is GetType(Model10.TextBox) Then
                                Dim txt As Model10.TextBox = CType(mem, Model10.TextBox)
                                If txt.ParentRelation Is Nothing And txt.DataField.Trim.ToLower = ms.DestinationField.Trim.ToLower Then
                                    Try
                                        box.Text = CStr(frm.Grid1.Current.RowData(txt.DataField))
                                    Catch ex As Exception
                                    End Try
                                End If
                                txt = Nothing
                            End If
                            mem = Nothing
                        End If
                        '-------------------
                        If isNew Then
                            ReRow()
                            totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                            OnResize(New EventArgs)
                        Else
                            ReRow()
                            OnResize(New EventArgs)
                        End If
                        SetRow(curPos)
                        '-------------------
                        Dim y As Integer

                        Dim row As Model10.Row
                        For Each row In content.Rows
                            If row.Index = curPos.RowIndex Then
                                If isNew Then
                                    body.Invalidate(New Rectangle(0, y, body.Width, body.Height - y))
                                    If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, band.Height - y))
                                Else
                                    body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                                    If Not wasEdit Then
                                        If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, 16))
                                    End If
                                End If
                                Exit For
                            End If
                            y += row.Detail.Height
                        Next : row = Nothing
                        '-------------------
                        If Not wasEdit Then OnRowEdit(New EventArgs)
                    End If
                    '----------------------------------
                    Cursor.Current = Cursors.Default

                    ms = Nothing
                End If
            Case "Model10.Drilldown"
                If curPos.RowIndex > mCurrent.DataView.Count - 1 Then Editing()
                If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
                    If Final(curPos, True) Then
                        Dim drl As Model10.Drilldown = CType(button, Model10.Drilldown)
                        If Not drl.ChildRelation Is Nothing Then
                            Model10.[Global].FillChildData(mCurrent.Table, mCurrent.ParaRow, mCurrent.RowData, mRelation)
                            OnRowDrilldown(New Model10.DrilldownEventArgs(New Model10.Current(drl.ChildRelation.ChildTable, drl.ChildRelation, mCurrent.RowData.CreateChildView(drl.ChildRelation.DataRelation), mCurrent.RowData, mCurrent.ParaRow, mCurrent.DataView.Count, curPos.RowIndex + 1)))
                        End If
                        drl = Nothing
                    End If
                End If
            Case "Model10.Lookup"
                Dim lkp As Model10.Lookup = CType(button, Model10.Lookup)
                If Not lkp.ParentRelation Is Nothing Then
                    Dim tbl As Model10.Table
                    If lkp.StartupTable Is Nothing Then
                        tbl = lkp.ParentRelation.ParentTable
                    Else
                        tbl = lkp.StartupTable
                    End If
                    Lookup(New Model10.LookupEventArgs(curPos.RowIndex, mCurrent.DataView, lkp.ParentRelation, tbl))
                    tbl = Nothing
                End If
                lkp = Nothing
        End Select
    End Sub
    Private Sub ReadLabels(ByVal myRow As Model10.Row)
        Dim mem As Model10.Member
        For Each mem In myRow.Detail.Members
            If TypeOf mem Is Model10.Label Then
                Dim lbl As New Model10.Label(CType(mem, Model10.Label))
                If lbl.DataField <> "" Then
                    Try
                        Select Case lbl.Value
                            Case Model10.ValueType.DateTime
                                mCurrent.RowData(lbl.DataField) = Date.Now
                            Case Model10.ValueType.Title
                                mCurrent.RowData(lbl.DataField) = mCurrent.Table.Presentation.Name
                            Case Model10.ValueType.Path
                                mCurrent.RowData(lbl.DataField) = mCurrent.Table.Presentation.Path
                            Case Model10.ValueType.PageCount
                            Case Model10.ValueType.PageNumber
                            Case Model10.ValueType.RecordCount
                                mCurrent.RowData(lbl.DataField) = mCurrent.DataView.Count
                            Case Model10.ValueType.RecordNumber
                                mCurrent.RowData(lbl.DataField) = myRow.Index + 1
                            Case Model10.ValueType.UserId
                                mCurrent.RowData(lbl.DataField) = mUser.Id
                            Case Model10.ValueType.UserFullName
                                mCurrent.RowData(lbl.DataField) = mUser.FullName
                            Case Model10.ValueType.UserName
                                mCurrent.RowData(lbl.DataField) = mUser.Name
                        End Select
                    Catch ex As Exception
                    End Try
                End If
                lbl = Nothing
            End If
        Next : mem = Nothing
    End Sub
    Private Sub ReRow()
        If content.Rows.Count > 0 Then
            If content.Rows(0).Index <= curPos.RowIndex And curPos.RowIndex <= content.Rows(content.Rows.Count - 1).Index Then
                Dim row As Model10.Row = content.Rows(curPos.RowIndex - content.Rows(0).Index)
                row.Detail.Members.Clear()
                row.Detail.Height = mCurrent.Table.Detail.Height
                If row.Index <= mCurrent.DataView.Count - 1 Then
                    Dim dr As DataRowView = mCurrent.DataView(row.Index)
                    If Not dr.IsEdit And mLayout Is Nothing Then
                        Try
                            If mCurrent.Table.AutoFill Then Model10.[Global].FillChildData(mCurrent.Table, mCurrent.ParaRow, dr, mRelation)
                        Catch ex As Exception
                            MsgBox(ex.Message)
                        End Try
                    End If
                    FillSection(row.Detail, mCurrent.Table.Detail.Members, dr, row.Index, mCurrent.DataView.Count)
                Else
                    FillSection(row.Detail, mCurrent.Table.Detail.Members, Nothing, row.Index, mCurrent.DataView.Count)
                End If
                row = Nothing
            End If
        End If
    End Sub
    Private Sub SetCol1(ByVal row As Model10.Row, ByVal colName As String, ByVal y As Integer)
        Dim x As Integer = GetX()

        Dim mem As Model10.Member = row.Detail.Members(colName)
        If Not mem Is Nothing Then
            If mem.GetType Is GetType(Model10.TextBox) Then
                SetText(row, CType(mem, Model10.TextBox), x, y)
            Else
                box.Text = ""
                box.Visible = False

                Me.Focus()
            End If

            If curPos.MemberName = "" Then SetFocus() 'For Row Fucus Rectangle
            curPos.MemberName = colName 'curPos should be set before SetPos
            SetPos(mem)
        End If
        mem = Nothing
    End Sub
    Private Sub SetCol2(ByVal row As Model10.Row, ByVal colName As String, ByVal y As Integer)
        Dim x As Integer = GetX()

        Dim mem1 As Model10.Member = row.Detail.Members(colName)
        If Not mem1 Is Nothing Then
            If mem1.GetType Is GetType(Model10.TextBox) Then
                SetText(row, CType(mem1, Model10.TextBox), x, y)
            Else
                body.Invalidate(New Rectangle(x + mem1.Location.X, y + mem1.Location.Y, mem1.Size.Width, mem1.Size.Height))

                box.Text = ""
                box.Visible = False

                Me.Focus()
            End If

            Dim mem2 As Model10.Member = row.Detail.Members(curPos.MemberName)
            If Not mem2 Is Nothing Then
                If Not mem2.GetType Is GetType(Model10.TextBox) Then
                    body.Invalidate(New Rectangle(x + mem2.Location.X, y + mem2.Location.Y, mem2.Size.Width, mem2.Size.Height))
                End If
            End If
            mem2 = Nothing

            If curPos.MemberName = "" Then SetFocus() 'For Row Fucus Rectangle
            curPos.MemberName = colName 'curPos should be set before SetPos
            SetPos(mem1)
        End If
        mem1 = Nothing
    End Sub
    Private Sub SetCol3(ByVal row As Model10.Row, ByVal colName As String, ByVal y As Integer)
        Dim x As Integer = GetX()

        Dim mem As Model10.Member = row.Detail.Members(colName)
        If Not mem Is Nothing Then
            If TypeOf mem Is Model10.Button Then
                Dim btn As Model10.Button = CType(mem, Model10.Button)
                If btn.ButtonStyle = Model10.ButtonStyle.Normal Or btn.ButtonStyle = Model10.ButtonStyle.Flat Then
                    If (body.MouseButtons And MouseButtons.Left) = MouseButtons.Left Or space Then
                        body.Invalidate(New Rectangle(x + mem.Location.X, y + mem.Location.Y, mem.Size.Width, mem.Size.Height))
                    End If
                End If
                btn = Nothing
            End If
            SetPos(mem)
        End If
        mem = Nothing
    End Sub
    Private Sub SetFocus()
        Dim y As Integer

        Dim row As Model10.Row
        For Each row In content.Rows
            If curPos.RowIndex = row.Index Then
                If curPos.MemberName = "" Then
                    body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                Else
                    Dim mem As Model10.Member = row.Detail.Members(curPos.MemberName)
                    If Not mem Is Nothing Then
                        Dim t As Type = mem.GetType
                        If t Is GetType(Model10.Label) Or t Is GetType(Model10.PictureBox) Or t Is GetType(Model10.CheckBox) Or TypeOf mem Is Model10.Button Then
                            body.Invalidate(New Rectangle(GetX() + mem.Location.X, y + mem.Location.Y, mem.Size.Width, mem.Size.Height))
                        End If
                        t = Nothing
                        mem = Nothing
                    End If
                End If
            End If

            y += row.Detail.Height
        Next : row = Nothing
    End Sub
    Private Sub SetParam(ByVal table As Model10.Table, ByVal dataRow As DataRowView, ByVal paraRow As DataRowView)
        If Not table.SelectCommand Is Nothing Then
            Dim foo As Boolean = False 'Not table.Filled

            Dim prm As Model10.Parameter
            For Each prm In table.SelectCommand.Parameters
                If Not prm.SourceColumn Is Nothing Then
                    If Not dataRow Is Nothing And Not paraRow Is Nothing Then
                        If dataRow.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                            If Not prm.Value Is dataRow(prm.SourceColumn) Then foo = True
                            prm.Value = dataRow(prm.SourceColumn)
                        Else
                            If paraRow.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                                If Not prm.Value Is paraRow(prm.SourceColumn) Then foo = True
                                prm.Value = paraRow(prm.SourceColumn)
                            End If
                        End If
                    ElseIf Not dataRow Is Nothing Then
                        If dataRow.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                            If Not prm.Value Is dataRow(prm.SourceColumn) Then foo = True
                            prm.Value = dataRow(prm.SourceColumn)
                        End If
                    ElseIf Not paraRow Is Nothing Then
                        If paraRow.DataView.Table.Columns.Contains(prm.SourceColumn) Then
                            If Not prm.Value Is paraRow(prm.SourceColumn) Then foo = True
                            prm.Value = paraRow(prm.SourceColumn)
                        End If
                    End If
                End If
                If prm.Value Is Nothing Then prm.Value = DBNull.Value
            Next : prm = Nothing
        End If
    End Sub
    Private Sub SetPos(ByVal mem As Model10.Member)
        If Not hsb Is Nothing Then
            If RightToLeft = RightToLeft.Yes Then
                Dim p1 As Integer = mCurrent.Table.Width - mem.Location.X - mem.Size.Width
                Dim p2 As Integer = mCurrent.Table.Width - mem.Location.X - body.Width
                If p1 <= hsb.Value And hsb.Value <= p2 Then
                ElseIf p1 < hsb.Value Then
                    hsb.Value = p1
                    body.Invalidate()
                ElseIf hsb.Value < p2 Then
                    hsb.Value = p2
                    body.Invalidate()
                End If
            Else
                Dim p1 As Integer = mem.Location.X
                Dim p2 As Integer = mem.Location.X + mem.Size.Width - body.Width
                If p1 <= hsb.Value And hsb.Value <= p2 Then
                ElseIf p1 < hsb.Value Then
                    hsb.Value = p1
                    body.Invalidate()
                ElseIf hsb.Value < p2 Then
                    hsb.Value = p2
                    body.Invalidate()
                End If
            End If
        End If
    End Sub
    Private Sub SetRow(ByVal pos As Avand.Position, Optional ByVal force As Boolean = False)
        force = pos.RowIndex <> curPos.RowIndex Or force
        If pos.RowIndex <> curPos.RowIndex Or pos.MemberName <> curPos.MemberName Then
            rePos = True
            mTextMode = False
        End If
        If content.Rows.Count <> 0 Then
            Dim lastRowIndex As Integer = content.Rows(content.Rows.Count - 1).Index
            If pos.RowIndex < content.Rows(0).Index Then
                If curPos.MemberName = "" Then SetFocus() 'For Row Fucus Rectangle

                curPos.RowIndex = pos.RowIndex
                curPos.MemberName = pos.MemberName
                If Not vsb Is Nothing Then vsb.Value = pos.RowIndex

                Dim mem As Model10.Member = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
                If Not mem Is Nothing Then SetPos(mem)
                mem = Nothing
            ElseIf content.Rows(0).Index <= pos.RowIndex And (pos.RowIndex < lastRowIndex Or (pos.RowIndex = lastRowIndex And Not [partial])) Then
                If clear Then
                    If curPos.MemberName = "" Then SetFocus() 'For Row Fucus Rectangle

                    curPos.RowIndex = pos.RowIndex
                    curPos.MemberName = pos.MemberName

                    OnResize(New EventArgs)
                    SetRow(curPos)
                Else
                    Dim y As Integer

                    Dim row As Model10.Row
                    For Each row In content.Rows
                        If (row.Index = pos.RowIndex Or row.Index = curPos.RowIndex) And pos.RowIndex <> curPos.RowIndex Then
                            body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                            If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, row.Detail.Height))
                        End If
                        If row.Index = pos.RowIndex Then
                            If pos.RowIndex = curPos.RowIndex Then
                                If pos.MemberName = curPos.MemberName Then
                                    SetCol3(row, pos.MemberName, y)
                                Else
                                    SetCol2(row, pos.MemberName, y)
                                End If
                            Else
                                SetCol1(row, pos.MemberName, y)
                            End If
                        End If
                        y += row.Detail.Height
                    Next : row = Nothing

                    curPos.RowIndex = pos.RowIndex
                End If
            ElseIf content.Rows.Count = 1 And content.Rows(0).Index = pos.RowIndex And [partial] Then
                If clear Then
                    If curPos.MemberName = "" Then SetFocus() 'For Row Fucus Rectangle

                    curPos.RowIndex = pos.RowIndex
                    curPos.MemberName = pos.MemberName

                    OnResize(New EventArgs)
                    SetRow(curPos)
                Else
                    If pos.MemberName = curPos.MemberName Then
                        SetCol3(content.Rows(0), pos.MemberName, 0)
                    Else
                        SetCol2(content.Rows(0), pos.MemberName, 0)
                    End If
                    curPos.RowIndex = pos.RowIndex
                End If
            Else
                If curPos.MemberName = "" Then SetFocus() 'For Row Fucus Rectangle

                curPos.RowIndex = pos.RowIndex
                curPos.MemberName = pos.MemberName

                Dim k As Integer = pos.RowIndex
                Dim y As Integer

                Dim h As Integer = Height - headerHeight - footerHeight
                '---------------
                If Not hsb Is Nothing Then h -= hsb.Height

                While k >= 0 And y < h
                    Dim row As Model10.Row = GetRow(k)
                    If y + row.Detail.Height > h Then Exit While
                    y += row.Detail.Height
                    row = Nothing
                    k -= 1
                End While

                If k + 1 < pos.RowIndex Then
                    If Not vsb Is Nothing Then vsb.Value = k + 1
                Else
                    If Not vsb Is Nothing Then vsb.Value = pos.RowIndex
                End If

                Dim mem As Model10.Member = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
                If Not mem Is Nothing Then SetPos(mem)
                mem = Nothing
            End If
        End If
        rePos = False
        If force Then OnRowChange(New EventArgs)
    End Sub
    Private Sub SetText(ByVal row As Model10.Row, ByVal txt As Model10.TextBox, ByVal x As Integer, ByVal y As Integer)
        Dim b As Integer
        Select Case txt.Border3DStyle
            Case Windows.Forms.Border3DStyle.Flat : b = CInt(txt.BorderWidth)
            Case Windows.Forms.Border3DStyle.RaisedInner, Windows.Forms.Border3DStyle.RaisedOuter, Windows.Forms.Border3DStyle.SunkenInner, Windows.Forms.Border3DStyle.SunkenOuter : b = 1
            Case Windows.Forms.Border3DStyle.Bump, Windows.Forms.Border3DStyle.Etched, Windows.Forms.Border3DStyle.Raised, Windows.Forms.Border3DStyle.Sunken : b = 2
        End Select

        If txt.BackColor.Equals(Color.Transparent) Then
            If row.Detail.BackColor.Equals(Color.Transparent) Then
                box.BackColor = SystemColors.Window
            Else
                box.BackColor = row.Detail.BackColor
            End If
        Else
            box.BackColor = txt.BackColor
        End If
        If txt.ForeColor.Equals(Color.Transparent) Then
            box.ForeColor = SystemColors.ControlText
        Else
            box.ForeColor = txt.ForeColor
        End If
        box.Font = txt.Font
        If txt.RightToLeft = RightToLeft.Inherit Then
            If mCurrent.Table.Presentation.RightToLeft = RightToLeft.Inherit Then
                If Me.RightToLeft = RightToLeft.Inherit Then
                Else
                    box.RightToLeft = Me.RightToLeft
                End If
            Else
                box.RightToLeft = mCurrent.Table.Presentation.RightToLeft
            End If
        Else
            box.RightToLeft = txt.RightToLeft
        End If
        Select Case box.RightToLeft
            Case RightToLeft.No
                Select Case txt.Alignment
                    Case HorizontalAlignment.Left : box.TextAlign = txt.Alignment.Left
                    Case HorizontalAlignment.Right : box.TextAlign = txt.Alignment.Right
                    Case HorizontalAlignment.Center : box.TextAlign = txt.Alignment.Center
                End Select
            Case RightToLeft.Yes
                Select Case txt.Alignment
                    Case HorizontalAlignment.Left : box.TextAlign = txt.Alignment.Right
                    Case HorizontalAlignment.Right : box.TextAlign = txt.Alignment.Left
                    Case HorizontalAlignment.Center : box.TextAlign = txt.Alignment.Center
                End Select
            Case RightToLeft.Inherit
        End Select
        box.WordWrap = txt.NoWrap
        box.MaxLength = 0
        box.Mask = txt.Mask
        If txt.DataField = "" Then 'Or Not txt.ParentRelation Is Nothing
            box.ReadOnly = True
            box.Text = txt.Text
        Else
            If txt.ParentRelation Is Nothing Then
                Try
                    Dim dc As DataColumn = mCurrent.Table.DataTable.Columns(txt.DataField)
                    If dc.MaxLength < 0 Then box.MaxLength = 0 Else box.MaxLength = dc.MaxLength
                    If row.Index > mCurrent.DataView.Count - 1 Then
                        box.ReadOnly = dc.ReadOnly
                        box.Text = txt.Text
                    Else
                        Dim dr As DataRowView = mCurrent.DataView(row.Index)
                        Dim obj As Object = dr(txt.DataField)
                        If IsDBNull(obj) Then box.Text = txt.Text Else box.Text = obj.ToString
                        obj = Nothing
                        If dr.IsNew Then
                            box.ReadOnly = dc.ReadOnly
                        Else
                            If mCurrent.Table.UpdateCommand Is Nothing Then
                                box.ReadOnly = True
                            Else
                                box.ReadOnly = dc.ReadOnly
                            End If
                        End If
                        dr = Nothing
                    End If
                    dc = Nothing
                Catch ex As Exception
                    box.ReadOnly = True
                    box.Text = txt.Text
                End Try
            Else
                Try
                    Dim dc As DataColumn = txt.ParentRelation.DataRelation.ParentTable.Columns(txt.DataField)
                    box.ReadOnly = False 'dc.ReadOnly
                    box.Text = txt.Text
                    dc = Nothing
                Catch ex As Exception
                    box.ReadOnly = True
                    box.Text = txt.Text
                End Try
            End If
        End If
        'vvv
        box.Location = New Point(x + txt.Location.X + txt.LeftMargin + b + body.Left, y + txt.Location.Y + txt.TopMargin + b + body.Top)
        box.Size = New Size(txt.Size.Width - txt.LeftMargin - txt.RightMargin - 2 * b, txt.Size.Height - txt.TopMargin - txt.BottomMargin - 2 * b)
        'vvv
        box.Visible = True
        body.SendToBack()
        box.Focus()
        box.SelectAll()

        If Not mTextMode Then
            mTextMode = True
        End If
    End Sub
    Private Sub WriteMessage(ByVal row As DataRowView, ByVal text As String)
        Dim eField As String = mCurrent.Table.ErrorField.Trim
        If eField <> "" Then
            Try
                row(eField) = text
            Catch ex1 As Exception
            End Try
        End If
    End Sub

    Protected Overridable Sub OnRequestBack(ByVal e As EventArgs)
        RaiseEvent RequestBack(Me, e)
    End Sub
    Protected Overridable Sub OnRowChange(ByVal e As EventArgs)
        If 0 <= curPos.RowIndex And curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
            mCurrent.RowData = mCurrent.DataView(curPos.RowIndex)
        Else
            mCurrent.RowData = Nothing
        End If
        RaiseEvent RowChange(Me, e)
    End Sub
    Protected Overridable Sub OnRowChangeCommitted(ByVal e As EventArgs)
        lastPos = curPos.RowIndex
        RaiseEvent RowChangeCommitted(Me, e)
    End Sub
    Protected Overridable Sub OnRowDoubleClick(ByVal e As EventArgs)
        RaiseEvent RowDoubleClick(Me, e)
    End Sub
    Protected Overridable Sub OnRowSelect(ByVal e As EventArgs)
        RaiseEvent RowSelect(Me, e)
    End Sub
    Protected Overridable Sub OnRowEdit(ByVal e As EventArgs)
        Mousing()
        RaiseEvent RowEdit(Me, e)
    End Sub
    Protected Overridable Sub OnRowUpdate(ByVal e As EventArgs)
        Mousing()
        RaiseEvent RowUpdate(Me, e)
    End Sub
    Protected Overridable Sub OnRowCancel(ByVal e As EventArgs)
        Mousing()
        RaiseEvent RowCancel(Me, e)
    End Sub
    Protected Overridable Sub OnRowDelete(ByVal e As EventArgs)
        RaiseEvent RowDelete(Me, e)
    End Sub
    Protected Overridable Sub OnRowDrilldown(ByVal e As Model10.DrilldownEventArgs)
        RaiseEvent RowDrilldown(Me, e)
    End Sub

    Protected Overrides Function IsInputKey(ByVal keyData As System.Windows.Forms.Keys) As Boolean
        Select Case keyData
            Case Keys.Up, Keys.Down, Keys.Left, Keys.Right, Keys.Tab, CType(65545, Windows.Forms.Keys) : Return True
        End Select
    End Function

    Protected Overrides Sub OnGotFocus(ByVal e As System.EventArgs)
        MyBase.OnGotFocus(e)

        SetFocus()
    End Sub
    Protected Overrides Sub OnLostFocus(ByVal e As System.EventArgs)
        MyBase.OnLostFocus(e)

        SetFocus()
    End Sub
    Protected Overrides Sub OnKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        MyBase.OnKeyDown(e)

        KeyDowning(e.KeyCode, e.Shift)
        e.Handled = True
    End Sub
    Protected Overrides Sub OnKeyUp(ByVal e As System.Windows.Forms.KeyEventArgs)
        MyBase.OnKeyUp(e)

        KeyUpping(e.KeyCode)
    End Sub
    Protected Overrides Sub OnMouseWheel(ByVal e As System.Windows.Forms.MouseEventArgs)
        MyBase.OnMouseWheel(e)

        MouseWheeling(e)
    End Sub
    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)

        Dim foc As Boolean = Me.ContainsFocus

        Static pic As PictureBox
        If Not mCurrent Is Nothing And Not content Is Nothing Then
            Dim d As Integer

            Dim h, v As Boolean
            Dim width_ As Integer = Width - bandWidth
            Dim height_ As Integer = Height - headerHeight - footerHeight
            Dim width_16 As Integer = width_ - 16 : If width_16 < 0 Then width_16 = 0
            Dim height_16 As Integer = height_ - 16 : If height_16 < 0 Then height_16 = 0
            '------------------
            If mCurrent.Table.Width <= width_ And totalHeight <= height_ Then
                h = False : v = False
            ElseIf mCurrent.Table.Width <= width_16 And height_ < totalHeight Then
                h = False : v = True
            ElseIf width_ < mCurrent.Table.Width And totalHeight <= height_16 Then
                h = True : v = False
            Else
                h = True : v = True
            End If

            If h Then
                d = mCurrent.Table.Width - (width_ - CInt(IIf(v, 16, 0)))
                If hsb Is Nothing Then
                    hsb = New HScrollBar
                    hsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, CInt(IIf(v, 16, 0)), 0)), Height - 16)
                    Controls.Add(hsb)
                    AddHandler hsb.ValueChanged, AddressOf hsb_ValueChanged
                    hsb.BringToFront()
                    hsb.Cursor = Cursors.Default
                    hsb.Height = 16
                    hsb.SmallChange = 10
                    hsb.LargeChange = 100
                End If
                hsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, CInt(IIf(v, 16, 0)), 0)), Height - 16)
                hsb.Width = Width - CInt(IIf(v, 16, 0))
                hsb.Maximum = d + hsb.LargeChange - 1
                If d < hsb.Value Then hsb.Value = d Else If RightToLeft = RightToLeft.Yes Then FitBox()
            Else
                If Not hsb Is Nothing Then
                    hsb.Value = 0
                    RemoveHandler hsb.ValueChanged, AddressOf hsb_ValueChanged
                    Controls.Remove(hsb)
                    hsb = Nothing
                End If
                If RightToLeft = RightToLeft.Yes Then FitBox()
            End If

            If v Then
                If vsb Is Nothing Then
                    vsb = New VScrollBar
                    vsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, 0, Width - 16)), 0)
                    Controls.Add(vsb)
                    AddHandler vsb.ValueChanged, AddressOf vsb_ValueChanged
                    vsb.BringToFront()
                    vsb.Cursor = Cursors.Default
                    vsb.Width = 16
                    vsb.SmallChange = 1
                    vsb.LargeChange = mCurrent.Table.PageSize
                End If
                vsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, 0, Width - 16)), 0)
                vsb.Height = Height - CInt(IIf(h, 16, 0))
                vsb.Maximum = totalRowCount - 1 + vsb.LargeChange - 1
            Else
                If Not vsb Is Nothing Then
                    vsb.Value = 0
                    RemoveHandler vsb.ValueChanged, AddressOf vsb_ValueChanged
                    Controls.Remove(vsb)
                    vsb = Nothing
                End If
            End If

            If Not vsb Is Nothing And Not hsb Is Nothing Then
                If pic Is Nothing Then
                    pic = New PictureBox
                    Controls.Add(pic)
                    pic.BringToFront()
                    pic.BackColor = SystemColors.Control
                End If
                pic.Size = New Size(16, 16)
                pic.Left = vsb.Left
                pic.Top = hsb.Top
            Else
                If Not pic Is Nothing Then
                    Controls.Remove(pic)
                    pic = Nothing
                End If
            End If
        Else
            If Not hsb Is Nothing Then
                hsb.Value = 0
                hsb = Nothing
            End If
            If Not vsb Is Nothing Then
                vsb.Value = 0
                vsb = Nothing
            End If
            If Not pic Is Nothing Then pic = Nothing
        End If

        If foc Then Me.Select()

        Dim sW, sH As Integer
        '--------------------
        If Not hsb Is Nothing Then sH = hsb.Height
        If Not vsb Is Nothing Then sW = vsb.Width

        Static bW As Integer
        If RightToLeft = RightToLeft.Yes Then
            If Not band Is Nothing Then
                band.Location = New Point(Width - bandWidth, headerHeight)
                band.Height = Height - headerHeight - footerHeight - sH
            End If

            body.Location = New Point(sW, headerHeight)
            body.Size = New Size(Width - bandWidth - sW, Height - headerHeight - footerHeight - sH)
            If bW <> body.Width Then body.Invalidate()

            If Not header Is Nothing Then
                header.Location = New Point(sW, 0)
                header.Width = Width - sW
                Static hW As Integer
                If hW <> header.Width Then header.Invalidate()
                hW = header.Width
            End If
            If Not footer Is Nothing Then
                footer.Location = New Point(sW, Height - footerHeight - sH)
                footer.Width = Width - sW
                Static fW As Integer
                If fW <> footer.Width Then footer.Invalidate()
                fW = footer.Width
            End If
        Else
            If Not band Is Nothing Then
                band.Location = New Point(0, headerHeight)
                band.Height = Height - headerHeight - footerHeight - sH
            End If

            body.Location = New Point(bandWidth, headerHeight)
            body.Size = New Size(Width - bandWidth - sW, Height - headerHeight - footerHeight - sH)
            If bW <> body.Width And curPos.MemberName = "" And Not content Is Nothing Then 'only for row focus rectangle
                Dim row As Model10.Row, y As Integer
                For Each row In content.Rows
                    If row.Index = curPos.RowIndex Then
                        body.Invalidate(New Rectangle(0, y, body.Size.Width, row.Detail.Height))
                        Exit For
                    End If
                    y += row.Detail.Height
                Next : row = Nothing
            End If

            If Not header Is Nothing Then
                header.Location = New Point(0, 0)
                header.Width = Width - sW
            End If
            If Not footer Is Nothing Then
                footer.Location = New Point(0, Height - footerHeight - sH)
                footer.Width = Width - sW
            End If
        End If
        bW = body.Width

        If Not mCurrent Is Nothing And Not content Is Nothing Then
            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
        End If
    End Sub

    Public Property Connections() As Model10.ConnectionCollection
        Get
            Return mConnections
        End Get
        Set(ByVal Value As Model10.ConnectionCollection)
            mConnections = Value
        End Set
    End Property
    Public Property Current() As Model10.Current
        Get
            Return mCurrent
        End Get
        Set(ByVal Value As Model10.Current)
            mCurrent = Value
        End Set
    End Property
    Public Property DataRowIndex() As Integer
        Get
            Return curPos.RowIndex
        End Get
        Set(ByVal Value As Integer)
            If Not mCurrent Is Nothing Then
                If Value <= totalRowCount - 1 And Value >= 0 Then
                    If Final(New Avand.Position(Value, curPos.MemberName)) Then
                        RaiseEvent RowChangeCommitted(Me, New EventArgs)
                        curPos.RowIndex = Value
                    End If
                End If
            End If
        End Set
    End Property
    Public Property Layouting() As Avand.Layout
        Get
            Return mLayout
        End Get
        Set(ByVal Value As Avand.Layout)
            mLayout = Value
        End Set
    End Property
    Public Property MemberName() As String
        Get
            Return curPos.MemberName
        End Get
        Set(ByVal Value As String)
            curPos.MemberName = Value
        End Set
    End Property
    Public Property MultiSelect() As Model10.MultiSelect
        Get
            Return mMultiSelect
        End Get
        Set(ByVal Value As Model10.MultiSelect)
            mMultiSelect = Value
        End Set
    End Property
    Public Property OleDbConnection() As OleDb.OleDbConnection
        Get
            Return mOleDbConnection
        End Get
        Set(ByVal Value As OleDb.OleDbConnection)
            mOleDbConnection = Value
        End Set
    End Property
    Public Property ParentFormView() As Avand.FormView
        Get
            Return mParentFormView
        End Get
        Set(ByVal Value As Avand.FormView)
            mParentFormView = Value
        End Set
    End Property
    Public Property PersistRow() As DataRowView
        Get
            Return mPersistRow
        End Get
        Set(ByVal Value As DataRowView)
            mPersistRow = Value
        End Set
    End Property
    Public Property Relation() As Model10.Relation
        Get
            Return mRelation
        End Get
        Set(ByVal Value As Model10.Relation)
            mRelation = Value
        End Set
    End Property
    Public Property TextMode() As Boolean
        Get
            Return mTextMode
        End Get
        Set(ByVal Value As Boolean)
            mTextMode = Value
        End Set
    End Property
    Public Property User() As Model10.User
        Get
            Return mUser
        End Get
        Set(ByVal Value As Model10.User)
            mUser = Value
        End Set
    End Property

    Public ReadOnly Property [ReadOnly]() As Boolean
        Get
            Return box.ReadOnly
        End Get
    End Property
    Public Overrides Property Text() As String
        Get
            Return box.Text
        End Get
        Set(ByVal Value As String)
            box.Text = Value
        End Set
    End Property
    Public ReadOnly Property SelectedText() As String
        Get
            Return box.SelectedText
        End Get
    End Property
    Public ReadOnly Property SelectionStart() As Integer
        Get
            Return box.SelectionStart
        End Get
    End Property
    Public ReadOnly Property SelectionLength() As Integer
        Get
            Return box.SelectionLength
        End Get
    End Property

    Public Function Updating() As Boolean
        Updating = Final(curPos, True)
    End Function

    Public Sub Editing()
        Dim wasEdit, isNew As Boolean
        Dim dr As DataRowView
        If mCurrent.RowData Is Nothing Then
            dr = mCurrent.DataView.AddNew
            mCurrent.RowData = dr '  
            isNew = True
        Else
            dr = mCurrent.RowData
            wasEdit = dr.IsEdit
            If Not dr.IsEdit Then dr.BeginEdit()
        End If
        dr = Nothing
        '-------------------
        If isNew Then
            ReRow()
            'rePos = True : mtextMode = False
            totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
            OnResize(New EventArgs)
        Else
            If Not wasEdit Then
                ReRow()
                'rePos = True : mtextMode = False
                OnResize(New EventArgs)
            End If
        End If
        SetRow(curPos)
        '-------------------
        Dim y As Integer, trap As Boolean

        Dim row As Model10.Row
        For Each row In content.Rows
            If row.Index = curPos.RowIndex Then
                If isNew Then
                    body.Invalidate(New Rectangle(0, y, body.Width, body.Height - y))
                    If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, band.Height - y))
                Else
                    If wasEdit Then
                        'body.Invalidate(New Rectangle(GetX() + chk.Location.X, y + chk.Location.Y, chk.Size.Width, chk.Size.Height))
                    Else
                        body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                        If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, 16))
                    End If
                End If
                Exit For
            End If
            y += row.Detail.Height
        Next : row = Nothing
        '-------------------
        If Not wasEdit Then OnRowEdit(New EventArgs)
    End Sub
    Public Sub Canceling(ByVal dataRow As DataRowView)
        If dataRow.IsNew Then
            dataRow.CancelEdit()

            totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
            ReRow()
            rePos = True : mTextMode = False
            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
            OnResize(New EventArgs)
            SetRow(curPos, True)

            body.Invalidate()
            If Not band Is Nothing Then band.Invalidate()

            OnRowCancel(New EventArgs)
        ElseIf dataRow.IsEdit Then
            dataRow.CancelEdit()

            ReRow()
            rePos = True : mTextMode = False
            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
            OnResize(New EventArgs)
            SetRow(curPos)

            body.Invalidate()
            If Not band Is Nothing Then band.Invalidate()

            OnRowCancel(New EventArgs)
        Else
            If mTextMode Then 'Ready For Back
                box.Visible = False
                mTextMode = False
            End If
            curPos.MemberName = ""
            Me.Select()
            SetFocus()
        End If
    End Sub
    Public Sub Copying()
        SetRow(curPos, True)
        If box.Visible Then
            box.Copy()
            Exit Sub
        End If
        If mCurrent.RowData Is Nothing Then Exit Sub

        mPersistRow = mCurrent.RowData
    End Sub
    Public Sub Deleting(Optional ByVal forceRowDelete As Boolean = False)
        SetRow(curPos, True)
        If box.Visible And Not forceRowDelete Then
            box.Cut()
            Exit Sub
        End If
        If mCurrent.RowData Is Nothing Then Exit Sub
        If curPos.RowIndex > mCurrent.DataView.Count Then
            Exit Sub
        Else
            If mCurrent.Table.DeleteCommand Is Nothing Then Exit Sub
        End If

        If Not mCurrent.Table.DeleteCommand Is Nothing Then
            body.Cursor = Cursors.Default
            If MessageBox.Show("Row will be deleted.", "Deleting", MessageBoxButtons.YesNo, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button2) = DialogResult.Yes Then
                Try
                    Dim isNew As Boolean = mCurrent.RowData.IsNew
                    ReadLabels(GetRow(curPos.RowIndex))
                    mCurrent.RowData.Row.AcceptChanges() '   ReadLabels  
                    mCurrent.RowData.Delete()
                    If mLayout Is Nothing Then
                        If mCurrent.Table.AutoSave Then
                            Application.DoEvents()
                            Cursor.Current = Cursors.WaitCursor
                            '----------------------------------
                            Try
                                ''Fill New-------------------
                                'If Not mCurrent.ParaRow Is Nothing Then
                                '    If Not mCurrent.Table.OleDbDataAdapter.DeleteCommand Is Nothing Then
                                '        Dim prm As OleDb.OleDbParameter
                                '        For Each prm In mCurrent.Table.OleDbDataAdapter.DeleteCommand.Parameters
                                '            If Not Include(prm.SourceColumn, mCurrent.RowData) And Include(prm.SourceColumn, mCurrent.ParaRow) Then
                                '                prm.Value = mCurrent.ParaRow(prm.SourceColumn)
                                '            End If
                                '        Next : prm = Nothing
                                '    End If
                                'End If
                                ''---------------------------
                                mCurrent.Table.UpdateBackward()
                                'mCurrent.RowData.Row.AcceptChanges()
                                If Not mCurrent.DataRow Is Nothing Then
                                    Dim col As DataColumn
                                    For Each col In mCurrent.DataRow.Row.Table.Columns
                                        If Not col.ReadOnly Then
                                            mCurrent.DataRow.Row(col) = mCurrent.DataRow.Row(col)
                                            Exit For
                                        End If
                                    Next : col = Nothing
                                End If
                            Catch ex As Exception
                                mCurrent.RowData.Row.RejectChanges()
                                Avand.DataError.ShowError(ex, MessageBoxIcon.Error)
                            End Try
                            '----------------------------------
                            Cursor.Current = Cursors.Default
                        End If
                    Else
                        If Not isNew Then mCurrent.Table.DataTable.AcceptChanges()
                    End If

                    clear = True
                    totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                    If curPos.RowIndex > mCurrent.DataView.Count - 1 Then
                        If mCurrent.Table.InsertCommand Is Nothing Then
                            curPos.RowIndex = mCurrent.DataView.Count - 1
                        Else
                            If mCurrent.DataView.Count = 0 Then
                                curPos.RowIndex = mCurrent.DataView.Count
                            Else
                                curPos.RowIndex = mCurrent.DataView.Count - 1
                            End If
                        End If
                    End If
                    rePos = True : mTextMode = False
                    If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                    OnResize(New EventArgs)
                    SetRow(curPos, True)

                    OnRowDelete(New EventArgs)
                    OnRowChangeCommitted(New EventArgs)

                    If Not mCurrent.RowData Is Nothing Then
                        If Not mCurrent.RowData.IsNew Then
                            If Not mParentFormView Is Nothing Then
                                If mParentFormView.Grid1.Current.RowData Is Nothing Then
                                    Me.FindForm.Close()
                                Else
                                    If mParentFormView.Grid1.Current.RowData.Row.RowState = DataRowState.Detached _
                                    Or mParentFormView.Grid1.Current.RowData.Row.RowState = DataRowState.Deleted Then
                                        Me.FindForm.Close()
                                    End If
                                End If
                                mParentFormView.Refine()
                            End If
                        End If
                    End If
                Catch ex As Exception
                    Avand.DataError.ShowError(ex, MessageBoxIcon.Exclamation)
                End Try
            End If
        End If
    End Sub
    Public Sub Refreshing()
        If totalRowCount > mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing) Then
            Fill(True)
        End If
    End Sub
    Public Sub Lookup(ByVal e As Model10.LookupEventArgs)
        Dim frm As New Avand.FormView

        Application.DoEvents()
        Cursor.Current = Cursors.WaitCursor
        '----------------------------------
        frm.StartPosition = FormStartPosition.CenterParent
        frm.Size = e.Table.Size
        frm.Grid1.User = mUser
        frm.Grid1.Layouting = mLayout
        frm.Navigator1.Chain = New ArrayList
        frm.Grid1.Current = New Model10.Current(e.Table, Nothing, e.Table.Presentation.DataViewManager.CreateDataView(e.Table.DataTable), Nothing, Nothing, 1, 1)
        frm.Navigator1.Chain.Add(frm.Grid1.Current)

        frm.Grid1.ParentFormView = CType(Me.FindForm, Avand.FormView)
        frm.Grid1.Relation = e.Relation
        If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
            Dim dr As DataRow = mCurrent.RowData.Row.GetParentRow(e.Relation.DataRelation)

            Dim i As Integer, r As DataRowView
            For Each r In frm.Grid1.Current.DataView
                If r.Row Is dr Then
                    frm.Grid1.Current.RowData = r
                    Exit For
                End If
                i += 1
            Next : r = Nothing

            dr = Nothing
        End If
        frm.Fill(frm.Navigator1.Chain.Count = 1)

        Dim wasEdit, isNew As Boolean
        If curPos.RowIndex <= mCurrent.DataView.Count - 1 Then
            wasEdit = mCurrent.RowData.IsEdit
        Else
            isNew = True
        End If

        inter = False

        If frm.ShowDialog(Me.FindForm) = DialogResult.OK Then
            Dim mem As Model10.Member = GetRow(curPos.RowIndex).Detail.Members(curPos.MemberName)
            If Not mem Is Nothing Then
                If mem.GetType Is GetType(Model10.TextBox) Then
                    Dim txt As Model10.TextBox = CType(mem, Model10.TextBox)
                    If txt.ParentRelation Is e.Relation Then
                        Try
                            box.Text = CStr(frm.Grid1.Current.RowData(txt.DataField))
                        Catch ex As Exception
                        End Try
                    End If
                    txt = Nothing
                End If
                mem = Nothing
            End If
            '-------------------
            If isNew Then
                ReRow()
                totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                OnResize(New EventArgs)
            Else
                ReRow()
                OnResize(New EventArgs)
            End If
            SetRow(curPos)
            '-------------------
            Dim y As Integer

            Dim row As Model10.Row
            For Each row In content.Rows
                If row.Index = curPos.RowIndex Then
                    If isNew Then
                        body.Invalidate(New Rectangle(0, y, body.Width, body.Height - y))
                        If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, band.Height - y))
                    Else
                        body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                        If Not wasEdit Then
                            If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, 16))
                        End If
                    End If
                    Exit For
                End If
                y += row.Detail.Height
            Next : row = Nothing
            '-------------------
            If Not wasEdit Then OnRowEdit(New EventArgs)
        End If
        '----------------------------------
        Cursor.Current = Cursors.Default
    End Sub
    Public Sub Pasting()
        SetRow(curPos, True)
        If box.Visible Then
            box.Paste()
            Exit Sub
        End If
        If curPos.RowIndex > mCurrent.DataView.Count - 1 Then
            If mCurrent.Table.InsertCommand Is Nothing Then Exit Sub
        Else
            If mCurrent.RowData Is Nothing Then
                Exit Sub
            Else
                If mCurrent.RowData.IsNew Then
                    If mCurrent.Table.InsertCommand Is Nothing Then Exit Sub
                Else
                    If mCurrent.Table.UpdateCommand Is Nothing Then Exit Sub
                End If
            End If
        End If

        If Not mPersistRow Is Nothing Then
            Dim wasEdit, isNew As Boolean
            Dim dr As DataRowView
            If mCurrent.RowData Is Nothing Then
                dr = mCurrent.DataView.AddNew
                mCurrent.RowData = dr '  
                isNew = True
            Else
                dr = mCurrent.RowData
                wasEdit = dr.IsEdit
                If Not dr.IsEdit Then dr.BeginEdit()
            End If

            Dim c As DataColumn
            For Each c In mCurrent.Table.DataTable.Columns
                If Not c.AutoIncrement And c.ColumnName <> mCurrent.Table.Field Then
                    Try
                        dr(c.ColumnName) = mPersistRow(c.ColumnName)
                    Catch ex As Exception
                    End Try
                End If
            Next : c = Nothing

            dr = Nothing
            '-------------------
            ReRow()
            If isNew Then
                rePos = True : mTextMode = False
                totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)
                If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
                OnResize(New EventArgs)
            Else
                If Not wasEdit Then
                    ReRow()
                    rePos = True : mTextMode = False
                    OnResize(New EventArgs)
                End If
            End If
            SetRow(curPos)
            '-------------------
            Dim y As Integer, trap As Boolean

            Dim row As Model10.Row
            For Each row In content.Rows
                If row.Index = curPos.RowIndex Then
                    If isNew Then
                        body.Invalidate(New Rectangle(0, y, body.Width, body.Height - y))
                        If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, band.Height - y))
                    Else
                        If wasEdit Then
                            body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                        Else
                            body.Invalidate(New Rectangle(0, y, body.Width, row.Detail.Height))
                            If Not band Is Nothing Then band.Invalidate(New Rectangle(0, y, bandWidth, 16))
                        End If
                    End If
                    Exit For
                End If
                y += row.Detail.Height
            Next : row = Nothing
            '-------------------
            If Not wasEdit Then OnRowEdit(New EventArgs)
        End If
    End Sub
    Public Sub Selecting()
        If Not mRelation Is Nothing Then
            Dim parentRow As DataRowView = mCurrent.RowData
            If parentRow.Row.Table Is mRelation.DataRelation.ParentTable Then
                Dim isEdit As Boolean

                If mParentFormView.Grid1.Current.RowData Is Nothing Then
                    mParentFormView.Grid1.Current.RowData = mParentFormView.Grid1.Current.DataView.AddNew
                Else
                    isEdit = mParentFormView.Grid1.Current.RowData.IsEdit
                    If Not mParentFormView.Grid1.Current.RowData.IsEdit Then mParentFormView.Grid1.Current.RowData.BeginEdit()
                End If

                Application.DoEvents()
                Cursor.Current = Cursors.WaitCursor
                '----------------------------------
                Try
                    Dim i As Integer
                    For i = 0 To UBound(mRelation.DataRelation.ParentColumns)
                        mParentFormView.Grid1.Current.RowData(mRelation.DataRelation.ChildColumns(i).ColumnName) = parentRow(mRelation.DataRelation.ParentColumns(i).ColumnName)
                    Next
                    Me.FindForm.DialogResult = DialogResult.OK
                Catch ex As Exception
                    MsgBox(ex.Message)
                    If Not isEdit Then mParentFormView.Grid1.Current.RowData.CancelEdit()
                End Try
                '----------------------------------
                Cursor.Current = Cursors.Default
            End If
            parentRow = Nothing
        End If
        If Not mMultiSelect Is Nothing Then
            If mMultiSelect.DataTable Is mCurrent.Table Then
                Dim isEdit As Boolean

                If mParentFormView.Grid1.Current.RowData Is Nothing Then
                    mParentFormView.Grid1.Current.RowData = mParentFormView.Grid1.Current.DataView.AddNew
                Else
                    isEdit = mParentFormView.Grid1.Current.RowData.IsEdit
                    If Not mParentFormView.Grid1.Current.RowData.IsEdit Then mParentFormView.Grid1.Current.RowData.BeginEdit()
                End If

                Application.DoEvents()
                Cursor.Current = Cursors.WaitCursor
                '----------------------------------
                Try
                    mParentFormView.Grid1.Current.RowData(mMultiSelect.DestinationField) = mCurrent.RowData(mMultiSelect.SourceField)
                    Me.FindForm.DialogResult = DialogResult.OK
                Catch ex As Exception
                    MsgBox(ex.Message)
                    If Not isEdit Then mParentFormView.Grid1.Current.RowData.CancelEdit()
                End Try
                '----------------------------------
                Cursor.Current = Cursors.Default
            End If
        End If
    End Sub
    Public Sub SelectAll()
        If TextMode Then box.SelectAll()
    End Sub

    Public Sub Fill(Optional ByVal simple As Boolean = False)
        If Not simple Then
            box.ContextMenu = Me.ContextMenu
            mPersistRow = Nothing

            If mCurrent.Table.Band Then
                If band Is Nothing Then
                    band = New Avand.Shot
                    Controls.Add(band)
                    AddHandler band.DoubleClick, AddressOf band_DoubleClick
                    AddHandler band.MouseDown, AddressOf band_MouseDown
                    AddHandler band.Paint, AddressOf band_Paint
                    band.BringToFront()
                    band.Width = 16 : bandWidth = 16
                End If
            Else
                If Not band Is Nothing Then
                    RemoveHandler band.DoubleClick, AddressOf band_DoubleClick
                    RemoveHandler band.MouseDown, AddressOf band_MouseDown
                    RemoveHandler band.Paint, AddressOf band_Paint
                    Controls.Remove(band)
                    band = Nothing
                    bandWidth = 0
                End If
            End If
            If content Is Nothing Then
                content = New Model10.Content
            End If
            If mCurrent.Table.GroupHeader Is Nothing Then
                If Not header Is Nothing Then
                    RemoveHandler header.Paint, AddressOf header_Paint
                    Controls.Remove(header)
                    header = Nothing
                End If
            Else
                If header Is Nothing Then
                    header = New Avand.Shot
                    Controls.Add(header)
                    AddHandler header.Paint, AddressOf header_Paint
                    header.BringToFront()
                End If
            End If
            If mCurrent.Table.GroupFooter Is Nothing Then
                If Not footer Is Nothing Then
                    RemoveHandler footer.Paint, AddressOf footer_Paint
                    Controls.Remove(footer)
                    footer = Nothing
                End If
            Else
                If footer Is Nothing Then
                    footer = New Avand.Shot
                    Controls.Add(footer)
                    AddHandler footer.Paint, AddressOf footer_Paint
                    footer.BringToFront()
                End If
            End If
        End If
        If Not hsb Is Nothing Then
            'hsb.Value = 0
            RemoveHandler hsb.ValueChanged, AddressOf hsb_ValueChanged
            Controls.Remove(hsb)
            hsb = Nothing
        End If
        If Not vsb Is Nothing Then
            'vsb.Value = 0
            RemoveHandler vsb.ValueChanged, AddressOf vsb_ValueChanged
            Controls.Remove(vsb)
            vsb = Nothing
        End If

        selPos.MemberName = "" : selPos.RowIndex = -1
        disPos.MemberName = "" : disPos.RowIndex = -1

        content.Clear() '        ǘ 
        clear = True
        totalRowCount = mCurrent.DataView.Count - CInt(Not mCurrent.Table.InsertCommand Is Nothing)

        curPos.RowIndex = -1
        If Not mCurrent.RowData Is Nothing Then
            Dim dr As DataRowView, i As Integer
            For Each dr In mCurrent.DataView
                If dr.Row Is mCurrent.RowData.Row Then
                    curPos.RowIndex = i : mCurrent.RowData = dr
                    Exit For
                End If
                i += 1
            Next : dr = Nothing
        End If
        If curPos.RowIndex = -1 Then
            mCurrent.RowData = Nothing
            Select Case mCurrent.Table.RowPosition
                Case Model10.RowStatus.First
                    If mCurrent.DataView.Count > 0 Then
                        curPos.RowIndex = 0
                        mCurrent.RowData = mCurrent.DataView(0)
                    Else
                        If Not mCurrent.Table.InsertCommand Is Nothing Then curPos.RowIndex = 0
                    End If
                Case Model10.RowStatus.Last
                    If mCurrent.DataView.Count > 0 Then
                        curPos.RowIndex = mCurrent.DataView.Count - 1
                        mCurrent.RowData = mCurrent.DataView(mCurrent.DataView.Count - 1)
                    Else
                        If Not mCurrent.Table.InsertCommand Is Nothing Then curPos.RowIndex = 0
                    End If
                Case Model10.RowStatus.AddNew
                    If mCurrent.Table.InsertCommand Is Nothing Then
                        If mCurrent.DataView.Count > 0 Then
                            curPos.RowIndex = mCurrent.DataView.Count - 1
                            mCurrent.RowData = mCurrent.DataView(mCurrent.DataView.Count - 1)
                        End If
                    Else
                        curPos.RowIndex = mCurrent.DataView.Count
                        mCurrent.RowData = Nothing
                    End If
            End Select
        End If


        'If curPos.RowIndex = -1 Or mCurrent.Table.Detail Is Nothing Then
        '    curPos.MemberName = ""
        'Else
        '    Dim memAr As Model10.Member() = GetRow(curPos.RowIndex).Detail.GetMembers
        '    If memAr Is Nothing Then
        '        curPos.MemberName = ""
        '    Else
        '        Dim mem As Model10.Member, foo As Boolean
        '        For Each mem In memAr
        '            If mem.Name = curPos.MemberName Then
        '                foo = True
        '                Exit For
        '            End If
        '        Next : mem = Nothing

        '        If Not foo Then curPos.MemberName = memAr(0).Name
        '    End If
        '    memAr = Nothing
        'End If
        curPos.MemberName = mCurrent.MemberName

        rePos = True : mTextMode = False
        FillBody(0)
        OnResize(New EventArgs)
        SetRow(curPos, True)
        OnRowChangeCommitted(New EventArgs)
    End Sub
End Class

Public Structure Position
    Private mRowIndex As Integer
    Private mMemberName As String

    Public Sub New(ByVal rowIndex As Integer, ByVal memberName As String)
        mRowIndex = rowIndex
        mMemberName = memberName
    End Sub

    Public Property RowIndex() As Integer
        Get
            Return mRowIndex
        End Get
        Set(ByVal Value As Integer)
            mRowIndex = Value
        End Set
    End Property
    Public Property MemberName() As String
        Get
            Return mMemberName
        End Get
        Set(ByVal Value As String)
            mMemberName = Value
        End Set
    End Property
End Structure
