Option Strict On
Option Explicit On 

Public Class Navigator
    Inherits System.Windows.Forms.UserControl

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

        'True  AllPaintingInWmPaint
        'False CacheText
        'False ContainerControl
        'False DoubleBuffer
        'False EnableNotifyMessage
        'False FixedHeight
        'False FixedWidth
        'False Opaque
        'False ResizeRedraw
        'True  Selectable
        'True  StandardClick
        'True  StandardDoubleClick
        'False SupportsTransparentBackColor
        'False UserMouse
        'True  UserPaint

        setstyle(ControlStyles.DoubleBuffer Or ControlStyles.Opaque, True)

        bmp = New Bitmap(1, 1)
        grp = Graphics.FromImage(bmp)
    End Sub

    'UserControl overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        grp.Dispose() : grp = Nothing
        bmp.Dispose() : bmp = Nothing

        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Navigator))
        Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
        '
        'ImageList1
        '
        Me.ImageList1.ImageSize = New System.Drawing.Size(16, 16)
        Me.ImageList1.ImageStream = CType(resources.GetObject("ImageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
        Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
        '
        'Navigator
        '
        Me.Cursor = System.Windows.Forms.Cursors.Hand
        Me.Name = "Navigator"

    End Sub

#End Region

    Dim bmp As Bitmap, grp As Graphics
    Dim hsb As HScrollBar, vsb As VScrollBar
    Dim [partial] As Boolean
    Dim theRowIndex As Integer
    Dim theRows As Model10.RowCollection
    Dim totalHeight, totalWidth As Integer
    Dim totalRowCount As Integer

    Private mChain As ArrayList
    Private mUser As Model10.User

    Public Event RowSelect(ByVal sender As Object, ByVal e As Model10.RowEventArgs)

    Protected Overrides Sub OnClick(ByVal e As System.EventArgs)
        MyBase.OnClick(e)

        Dim y As Integer
        Dim p As Point = Me.PointToClient(Me.MousePosition)

        Dim row As Model10.Row
        For Each row In theRows
            If y <= p.Y And p.Y <= y + row.Detail.Height Then
                If row.Index = theRowIndex Then OnRowSelect(New Model10.RowEventArgs(Nothing, theRowIndex))
                Exit For
            End If
            y += row.Detail.Height
        Next : row = Nothing
    End Sub
    Protected Overrides Sub OnMouseDown(ByVal e As System.Windows.Forms.MouseEventArgs)
        MyBase.OnMouseDown(e)

        Me.Parent.Focus()

        Dim y As Integer
        Dim p As Point = Me.PointToClient(Me.MousePosition)

        Dim row As Model10.Row
        For Each row In theRows
            If y <= p.Y And p.Y <= y + row.Detail.Height Then
                SetRow(New Avand.Position(row.Index, ""))
                Exit For
            End If
            y += row.Detail.Height
        Next : row = Nothing
    End Sub
    Protected Overrides Sub OnMouseUp(ByVal e As System.Windows.Forms.MouseEventArgs)
    End Sub
    Protected Overrides Sub OnMouseWheel(ByVal e As System.Windows.Forms.MouseEventArgs)
        MyBase.OnMouseWheel(e)

        MouseWheeling(e)
    End Sub
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)

        Try
            If theRows Is Nothing Then
                e.Graphics.Clear(Color.White)
                e.Graphics.DrawString("There is nothing to show...", Font, SystemBrushes.ControlText, 2, 2)
            Else
                Dim x As Integer = GetX()
                Dim y As Integer

                Dim row As Model10.Row
                For Each row In theRows
                    Dim vsbWidth As Integer
                    If Not vsb Is Nothing Then vsbWidth = 16

                    e.Graphics.FillRectangle(Brushes.White, 0, y, Me.Width, row.Detail.Height)
                    If Me.RightToLeft = RightToLeft.Yes Then
                        DrawMembers(row.Detail.Members, e.Graphics, vsbWidth + x + totalWidth - 16 * row.Index - row.Detail.Table.Width, y)
                        If theRowIndex = row.Index And Me.Focused Then
                            ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(vsbWidth, y, x + totalWidth - 16 * row.Index, row.Detail.Height), Color.Black, Color.White)
                        End If
                    Else
                        DrawMembers(row.Detail.Members, e.Graphics, x + 16 * row.Index, y)
                        If theRowIndex = row.Index And Me.Focused Then
                            ControlPaint.DrawFocusRectangle(e.Graphics, New Rectangle(x + 16 * row.Index, y, Me.Width - (x + 16 * row.Index) - vsbWidth, row.Detail.Height), Color.Black, Color.White)
                        End If
                    End If

                    y += row.Detail.Height
                Next : row = Nothing

                e.Graphics.FillRectangle(Brushes.White, 0, y, Me.Width, Me.Height - y)
            End If
        Catch ex As Exception
            Trace.WriteLine(ex.Message, "Navigator/me_Paint")
        End Try
    End Sub

    Private Function GetRow(ByVal rowIndex As Integer) As Model10.Row
        If theRows.Count = 0 Then
            GetRow = NewRow(rowIndex)
        Else
            If theRows(0).Index <= rowIndex And rowIndex <= theRows(theRows.Count - 1).Index Then
                GetRow = theRows(rowIndex - theRows(0).Index)
            Else
                GetRow = NewRow(rowIndex)
            End If
        End If
    End Function
    Private Function GetX() As Integer
        Dim w As Integer = Width '- bandWidth
        '---------------
        If Not vsb Is Nothing Then w -= vsb.Width

        If RightToLeft = RightToLeft.Yes Then
            GetX = w - totalWidth
            If Not hsb Is Nothing Then GetX += hsb.Value
        Else
            GetX = 0
            If Not hsb Is Nothing Then GetX += -hsb.Value
        End If
    End Function
    Private Function NewRow(ByVal rowIndex As Integer) As Model10.Row
        Dim current As Model10.Current = CType(mChain(rowIndex), Model10.Current)

        NewRow = New Model10.Row
        NewRow.Index = rowIndex
        NewRow.Detail = New Model10.Detail(current.Table.Detail, Color.Empty)
        FillSection(NewRow.Detail, current.Table.Detail.Members, current.RowData, rowIndex, current.DataView.Count)

        current = Nothing
    End Function

    Private Sub DrawMembers(ByVal members As Model10.MemberCollection, ByVal grp As Graphics, ByVal x As Integer, ByVal y As Integer)
        Dim mem As Model10.Member
        For Each mem In members
            If mem.GetType Is GetType(Model10.Line) Then
                CType(mem, Model10.Line).Draw(grp, x, y)
            ElseIf mem.GetType Is GetType(Model10.Frame) Then
                CType(mem, Model10.Frame).Draw(grp, x, y)
            ElseIf TypeOf mem Is Model10.Label Then
                Dim lbl As Model10.Label = CType(mem, Model10.Label)
                lbl.Draw(grp, lbl.Text, x, y, Me.RightToLeft, Color.Empty)
                lbl = Nothing
            ElseIf TypeOf mem Is Model10.PictureBox Then
                Dim pic As Model10.PictureBox = CType(mem, Model10.PictureBox)
                If pic.Image Is Nothing Then
                    CType(mem, Model10.Frame).Draw(grp, x, y)
                Else
                    pic.Draw(grp, x, y)
                End If
                pic = Nothing
            ElseIf TypeOf mem Is Model10.CheckBox Then
                CType(mem, Model10.CheckBox).Draw(grp, x, y)
            ElseIf TypeOf mem Is Model10.Button Then
                Dim btn As Model10.Button = CType(mem, Model10.Button)
                btn.DrawPressed(grp, btn.Text, x, y, Me.RightToLeft, Color.Empty)
                btn = Nothing
            ElseIf TypeOf mem Is Model10.Sub Then
                '...
            ElseIf TypeOf mem Is Model10.Chart Then
                Dim cht As Model10.Chart = CType(mem, Model10.Chart)
                cht.DrawChartF(grp, x, y)
                cht = Nothing
            End If
        Next : mem = Nothing
    End Sub
    Private Sub FillBody(ByVal newIndex As Integer)
        Dim k As Integer = newIndex
        Dim posMem As Model10.Member
        Dim rows As New Model10.RowCollection
        Dim y As Integer

        Dim h As Integer = Height
        '---------------
        If Not hsb Is Nothing Then h -= hsb.Height

        While k <= totalRowCount - 1 And y < h
            Dim row As Model10.Row = GetRow(k)
            rows.Add(row)

            y += row.Detail.Height
            row = Nothing
            k += 1
        End While

        [partial] = h < y

        theRows = rows 'theRows should be set before SetPos
        rows = Nothing
    End Sub
    Private Sub SetText(ByVal label As Model10.Label, ByVal dataRow As DataRowView, ByVal rowIndex As Integer, ByVal rowCount As Integer)
        If label.Value <> Model10.ValueType.None Then
            Select Case label.Value
                Case Model10.ValueType.DateTime
                    label.Text = Model10.FFormat(Date.Now.ToString, label.Format)
                Case Model10.ValueType.Title
                    label.Text = Model10.FFormat(label.Section.Table.Presentation.Name, label.Format)
                Case Model10.ValueType.Path
                    label.Text = Model10.FFormat(label.Section.Table.Presentation.Path, label.Format)
                Case Model10.ValueType.PageCount
                    label.Text = ""
                Case Model10.ValueType.PageNumber
                    label.Text = ""
                Case Model10.ValueType.RecordCount
                    label.Text = Model10.FFormat(rowCount, label.Format)
                Case Model10.ValueType.RecordNumber
                    label.Text = Model10.FFormat(rowIndex + 1, label.Format)
                Case Model10.ValueType.UserId
                    label.Text = Model10.FFormat(mUser.Id, label.Format)
                Case Model10.ValueType.UserFullName
                    label.Text = Model10.FFormat(mUser.FullName, label.Format)
                Case Model10.ValueType.UserName
                    label.Text = Model10.FFormat(mUser.Name, label.Format)
            End Select
        ElseIf label.DataField <> "" Then
            Dim obj As Object
            Try
                If dataRow Is Nothing Then
                    If label.ParentRelation Is Nothing Then
                        'obj = mCurrent.Table.DataTable.Columns(label.DataField).DefaultValue
                    Else
                        obj = label.ParentRelation.DataRelation.ParentTable.Columns(label.DataField).DefaultValue
                    End If
                Else
                    If label.ParentRelation Is Nothing Then
                        obj = dataRow(label.DataField)
                    Else
                        obj = dataRow.Row.GetParentRow(label.ParentRelation.DataRelation)(label.DataField)
                    End If
                End If
            Catch ex As Exception
                Try
                    'obj = mCurrent.ParaRow(label.DataField)
                Catch exx As Exception
                End Try
            End Try
            If Not IsDBNull(obj) Then label.Text = Model10.FFormat(obj, label.Format)
            obj = Nothing
        ElseIf label.Expression <> "" Then
            label.Text = Model10.FFormat(label.Section.Table.DataTable.Compute(label.Expression, label.Filter), label.Format)
        End If
    End Sub
    Private Sub FillSection(ByVal section As Model10.Section, ByVal members As Model10.MemberCollection, ByVal dataRow As DataRowView, Optional ByVal rowIndex As Integer = 1, Optional ByVal rowCount As Integer = 1)
        Dim current As Model10.Current = CType(mChain(rowIndex), Model10.Current)
        Dim dif As Integer

        Dim mem As Model10.Member
        For Each mem In members
            If mem.Visible And mem.Printable Then
                Select Case mem.GetType.ToString
                    Case "Model10.Line"
                        section.Members.Add(New Model10.Line(CType(mem, Model10.Line)), 0, 0)
                    Case "Model10.Frame"
                        section.Members.Add(New Model10.Frame(CType(mem, Model10.Frame)), 0, 0)
                    Case "Model10.Label", "Model10.TextBox"
                        Dim lbl As New Model10.Label(CType(mem, Model10.Label))
                        SetText(lbl, dataRow, rowIndex, rowCount)
                        section.Members.Add(lbl, 0, 0)
                        If lbl.AutoSize Then Model10.[Global].Measure(lbl, dif, grp, Me.RightToLeft)
                        lbl = Nothing
                        '------------------------
                    Case "Model10.PictureBox"
                        Dim pic As New Model10.PictureBox(CType(mem, Model10.PictureBox))
                        If pic.DataField <> "" Then
                            Try
                                Dim obj As Object
                                If dataRow Is Nothing Then
                                    obj = current.Table.DataTable.Columns(pic.DataField).DefaultValue
                                Else
                                    If pic.ParentRelation Is Nothing Then
                                        obj = dataRow(pic.DataField)
                                    Else
                                        obj = dataRow.Row.GetParentRow(pic.ParentRelation.DataRelation)(pic.DataField)
                                    End If
                                End If
                                Select Case TypeName(obj)
                                    Case "Byte()" : pic.Image = Model10.[Global].GetImage(CType(obj, Byte()))
                                    Case "String" : pic.Image = Image.FromFile(CStr(obj))
                                End Select
                                obj = Nothing
                            Catch ex As Exception
                            End Try
                        End If
                        section.Members.Add(pic, 0, 0)
                        pic = Nothing
                    Case "Model10.CheckBox"
                        Dim chk As New Model10.CheckBox(CType(mem, Model10.CheckBox))
                        Dim nov As Boolean
                        If Not nov Then
                            If chk.DataField <> "" Then
                                Try
                                    Dim obj As Object
                                    If dataRow Is Nothing Then
                                        obj = current.Table.DataTable.Columns(chk.DataField).DefaultValue
                                    Else
                                        If chk.ParentRelation Is Nothing Then
                                            obj = dataRow(chk.DataField)
                                        Else
                                            obj = dataRow.Row.GetParentRow(chk.ParentRelation.DataRelation)(chk.DataField)
                                        End If
                                    End If
                                    If IsDBNull(obj) Then
                                        chk.Checked = False
                                    Else
                                        chk.Checked = CBool(obj)
                                    End If
                                    obj = Nothing
                                Catch ex As Exception
                                End Try
                            End If
                            section.Members.Add(chk, 0, 0)
                        End If
                        chk = Nothing
                        '------------------------
                    Case "Model10.Sub"
                        '...
                        '...
                    Case "Model10.Chart"
                        Dim cht As New Model10.Chart(CType(mem, Model10.Chart))
                        section.Members.Add(cht, 0, 0)
                        cht = Nothing
                End Select
                If TypeOf mem Is Model10.Button Then
                    Dim btn As Model10.Button = CType(mem, Model10.Button)
                    If btn.ButtonStyle = Model10.ButtonStyle.PlusMines Then
                        section.Members.Add(New Model10.Button(CType(mem, Model10.Button)), 0, 0)
                    End If
                    btn = Nothing
                End If
            End If
        Next : mem = Nothing
        For Each mem In section.Members
            If mem.Visible Then
                If dif > 0 Then
                    Dim d As Integer
                    If TypeOf mem Is Model10.Label Then d = CType(mem, Model10.Label).Difference

                    If mem.Anchor = Model10.AnchorMode.TopAndBottom Then
                        mem.Size = New Drawing.Size(mem.Size.Width, mem.Size.Height + dif - d)
                    ElseIf mem.Anchor = Model10.AnchorMode.Bottom Then
                        mem.Location = New Drawing.Point(mem.Location.X, mem.Location.Y + dif - d)
                    ElseIf mem.Anchor = Model10.AnchorMode.None Then
                        mem.Location = New Drawing.Point(mem.Location.X, mem.Location.Y + (dif - d) \ 2)
                    End If
                End If
                If Not dataRow Is Nothing Then
                    If TypeOf mem Is Model10.Chart Then
                        CType(mem, Model10.Chart).FillChart(dataRow, False)
                    End If
                End If
            End If
        Next : mem = Nothing
        section.Height += dif
        current = Nothing
    End Sub
    Private Sub KeyDowning(ByVal keyCode As System.Windows.Forms.Keys, ByVal shift As Boolean)
        If totalRowCount > 0 Then
            If shift Then
                Select Case keyCode
                End Select
            Else
                Select Case keyCode
                    Case Keys.Up
                        Dim pos As Avand.Position
                        If theRowIndex - 1 < 0 Then
                            pos.RowIndex = theRowIndex
                        Else
                            pos.RowIndex = theRowIndex - 1
                        End If
                        SetRow(pos)
                    Case Keys.Down
                        Dim pos As Avand.Position
                        If theRowIndex + 1 > totalRowCount - 1 Then
                            pos.RowIndex = theRowIndex
                        Else
                            pos.RowIndex = theRowIndex + 1
                        End If
                        SetRow(pos)
                    Case Keys.PageUp
                        Dim h As Integer = Height
                        '---------------
                        If Not hsb Is Nothing Then h -= hsb.Height

                        Dim k As Integer = theRowIndex
                        Dim y As Integer

                        While k >= 0 And y < h
                            Dim row As Model10.Row = GetRow(k)
                            If y + row.Detail.Height > h Then Exit While
                            y += row.Detail.Height
                            row = Nothing
                            k -= 1
                        End While

                        Dim pos As Avand.Position
                        If k + 1 < theRowIndex Then
                            pos.RowIndex = k + 1
                        Else
                            'Keys.Up
                            If theRowIndex - 1 < 0 Then
                                pos.RowIndex = theRowIndex
                            Else
                                pos.RowIndex = theRowIndex - 1
                            End If
                        End If
                        SetRow(pos)
                    Case Keys.PageDown
                        Dim h As Integer = Height
                        '---------------
                        If Not hsb Is Nothing Then h -= hsb.Height

                        Dim k As Integer = theRowIndex
                        Dim y As Integer

                        While k <= totalRowCount - 1 And y < h
                            Dim row As Model10.Row = GetRow(k)
                            If y + row.Detail.Height > h Then Exit While
                            y += row.Detail.Height
                            row = Nothing
                            k += 1
                        End While

                        Dim pos As Avand.Position
                        If k - 1 > theRowIndex Then
                            pos.RowIndex = k - 1
                        Else
                            'Keys.Down
                            If theRowIndex + 1 > totalRowCount - 1 Then
                                pos.RowIndex = theRowIndex
                            Else
                                pos.RowIndex = theRowIndex + 1
                            End If
                        End If
                        SetRow(pos)
                    Case Keys.Enter
                        If theRowIndex >= 0 Then OnRowSelect(New Model10.RowEventArgs(Nothing, theRowIndex))
                End Select
            End If
        End If
    End Sub
    Private Sub ReRow()
        Dim current As Model10.Current = CType(mChain(theRowIndex), Model10.Current)
        If theRows.Count > 0 Then
            If theRows(0).Index <= theRowIndex And theRowIndex <= theRows(theRows.Count - 1).Index Then
                Dim row As Model10.Row = theRows(theRowIndex - theRows(0).Index)
                row.Detail.Members.Clear()
                row.Detail.Height = current.Table.Detail.Height
                FillSection(row.Detail, current.Table.Detail.Members, current.RowData, row.Index, current.DataView.Count)
                row = Nothing
            End If
        End If
        current = Nothing
    End Sub
    Private Sub SetFocus()
        Dim y As Integer

        Dim row As Model10.Row
        For Each row In theRows
            If theRowIndex = row.Index Then
                Me.Invalidate(New Rectangle(0, y, Me.Width, row.Detail.Height))
                Exit For
            End If

            y += row.Detail.Height
        Next : row = Nothing
    End Sub
    Private Sub SetRow(ByVal pos As Avand.Position)
        If theRows.Count <> 0 Then
            Dim lastRowIndex As Integer = theRows(theRows.Count - 1).Index
            If pos.RowIndex < theRows(0).Index Then
                theRowIndex = pos.RowIndex
                If Not vsb Is Nothing Then vsb.Value = pos.RowIndex
            ElseIf theRows(0).Index <= pos.RowIndex And (pos.RowIndex < lastRowIndex Or (pos.RowIndex = lastRowIndex And Not [partial])) Then
                Dim y As Integer

                Dim row As Model10.Row
                For Each row In theRows
                    If (row.Index = pos.RowIndex Or row.Index = theRowIndex) And pos.RowIndex <> theRowIndex Then
                        Me.Invalidate(New Rectangle(0, y, Me.Width, row.Detail.Height))
                    End If
                    y += row.Detail.Height
                Next : row = Nothing

                theRowIndex = pos.RowIndex
            ElseIf theRows.Count = 1 And theRows(0).Index = pos.RowIndex And [partial] Then
                theRowIndex = pos.RowIndex
            Else
                theRowIndex = pos.RowIndex

                Dim k As Integer = pos.RowIndex
                Dim y As Integer

                Dim h As Integer = Height
                '---------------
                If Not hsb Is Nothing Then h -= hsb.Height

                While k >= 0 And y < h
                    Dim row As Model10.Row = GetRow(k)
                    If y + row.Detail.Height > h Then Exit While
                    y += row.Detail.Height
                    row = Nothing
                    k -= 1
                End While

                If k + 1 < pos.RowIndex Then
                    If Not vsb Is Nothing Then vsb.Value = k + 1
                Else
                    If Not vsb Is Nothing Then vsb.Value = pos.RowIndex
                End If
            End If
        End If
    End Sub
    Private Sub MouseWheeling(ByVal e As MouseEventArgs)
        If MouseButtons = MouseButtons.None Then
            If Not vsb Is Nothing Then
                Dim i As Integer
                If e.Delta > 0 Then i = vsb.Value - 1
                If e.Delta < 0 Then i = vsb.Value + 1
                If i < vsb.Minimum Then i = vsb.Minimum
                If i > vsb.Maximum - vsb.LargeChange + 1 Then i = vsb.Maximum - vsb.LargeChange + 1
                vsb.Value = i
            End If
        End If
    End Sub

    Private Sub hsb_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.Invalidate()
    End Sub
    Private Sub vsb_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        Me.Invalidate()
        FillBody(vsb.Value)
    End Sub

    Protected Overridable Sub OnRowSelect(ByVal e As Model10.RowEventArgs)
        RaiseEvent RowSelect(Me, e)
    End Sub
    Protected Overrides Function IsInputKey(ByVal keyData As System.Windows.Forms.Keys) As Boolean
        Select Case keyData
            Case Keys.Up, Keys.Down, Keys.Left, Keys.Right : Return True ', Keys.Tab, CType(65545, Windows.Forms.Keys)
        End Select
    End Function

    Protected Overrides Sub OnGotFocus(ByVal e As System.EventArgs)
        MyBase.OnGotFocus(e)

        SetFocus()
    End Sub
    Protected Overrides Sub OnLostFocus(ByVal e As System.EventArgs)
        MyBase.OnLostFocus(e)

        SetFocus()
    End Sub
    Protected Overrides Sub OnKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
        MyBase.OnKeyDown(e)

        KeyDowning(e.KeyCode, e.Shift)
        e.Handled = True
    End Sub
    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)

        Static pic As PictureBox
        If Not theRows Is Nothing Then
            Dim d As Integer

            Dim h, v As Boolean
            Dim width_ As Integer = Width
            Dim height_ As Integer = Height
            Dim width_16 As Integer = width_ - 16 : If width_16 < 0 Then width_16 = 0
            Dim height_16 As Integer = height_ - 16 : If height_16 < 0 Then height_16 = 0
            '------------------
            If totalWidth <= width_ And totalHeight <= height_ Then
                h = False : v = False
            ElseIf totalWidth <= width_16 And height_ < totalHeight Then
                h = False : v = True
            ElseIf width_ < totalWidth And totalHeight <= height_16 Then
                h = True : v = False
            Else
                h = True : v = True
            End If
            h = False '<< 

            If h Then
                d = totalWidth - (width_ - CInt(IIf(v, 16, 0)))
                If hsb Is Nothing Then
                    hsb = New HScrollBar
                    hsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, CInt(IIf(v, 16, 0)), 0)), Height - 16)
                    Controls.Add(hsb)
                    AddHandler hsb.ValueChanged, AddressOf hsb_ValueChanged
                    hsb.BringToFront()
                    hsb.Cursor = Cursors.Default
                    hsb.Height = 16
                    hsb.SmallChange = 10
                    hsb.LargeChange = 100
                End If
                hsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, CInt(IIf(v, 16, 0)), 0)), Height - 16)
                hsb.Width = Width - CInt(IIf(v, 16, 0))
                hsb.Maximum = d + hsb.LargeChange - 1
            Else
                If Not hsb Is Nothing Then
                    hsb.Value = 0
                    RemoveHandler hsb.ValueChanged, AddressOf hsb_ValueChanged
                    Controls.Remove(hsb)
                    hsb = Nothing
                End If
            End If

            If v Then
                If vsb Is Nothing Then
                    vsb = New VScrollBar
                    vsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, 0, Width - 16)), 0)
                    Controls.Add(vsb)
                    AddHandler vsb.ValueChanged, AddressOf vsb_ValueChanged
                    vsb.BringToFront()
                    vsb.Cursor = Cursors.Default
                    vsb.Width = 16
                    vsb.SmallChange = 1
                    vsb.LargeChange = 10
                End If
                vsb.Location = New Point(CInt(IIf(RightToLeft = RightToLeft.Yes, 0, Width - 16)), 0)
                vsb.Height = Height - CInt(IIf(h, 16, 0))
                vsb.Maximum = totalRowCount - 1 + vsb.LargeChange - 1
            Else
                If Not vsb Is Nothing Then
                    vsb.Value = 0
                    RemoveHandler vsb.ValueChanged, AddressOf vsb_ValueChanged
                    Controls.Remove(vsb)
                    vsb = Nothing
                End If
            End If

            If Not vsb Is Nothing And Not hsb Is Nothing Then
                If pic Is Nothing Then
                    pic = New PictureBox
                    Controls.Add(pic)
                    pic.BringToFront()
                    pic.BackColor = SystemColors.Control
                End If
                pic.Size = New Size(16, 16)
                pic.Left = vsb.Left
                pic.Top = hsb.Top
            Else
                If Not pic Is Nothing Then
                    Controls.Remove(pic)
                    pic = Nothing
                End If
            End If
        Else
            If Not hsb Is Nothing Then
                hsb.Value = 0
                hsb = Nothing
            End If
            If Not vsb Is Nothing Then
                vsb.Value = 0
                vsb = Nothing
            End If
            If Not pic Is Nothing Then pic = Nothing
        End If


        Dim sW, sH As Integer
        '--------------------
        If Not hsb Is Nothing Then sH = hsb.Height
        If Not vsb Is Nothing Then sW = vsb.Width

        If RightToLeft = RightToLeft.Yes Then
            Static bW As Integer
            If bW <> Me.Width Then Me.Invalidate()
            bW = Me.Width
        Else
            If Not theRows Is Nothing Then
                Dim y As Integer

                Dim row As Model10.Row
                For Each row In theRows
                    If row.Index = theRowIndex Then
                        Me.Invalidate(New Rectangle(0, y, Me.Width - sW, row.Detail.Height))
                        Exit For
                    End If
                    y += row.Detail.Height
                Next : row = Nothing
            End If
        End If

        If Not theRows Is Nothing Then
            If vsb Is Nothing Then FillBody(0) Else FillBody(vsb.Value)
        End If
    End Sub

    Public Property Chain() As ArrayList
        Get
            Return mChain
        End Get
        Set(ByVal Value As ArrayList)
            mChain = Value
        End Set
    End Property
    Public Property User() As Model10.User
        Get
            Return mUser
        End Get
        Set(ByVal Value As Model10.User)
            mUser = Value
        End Set
    End Property

    Public Sub Fill()
        If Not hsb Is Nothing Then
            'hsb.Value = 0
            RemoveHandler hsb.ValueChanged, AddressOf hsb_ValueChanged
            Controls.Remove(hsb)
            hsb = Nothing
        End If
        If Not vsb Is Nothing Then
            'vsb.Value = 0
            RemoveHandler vsb.ValueChanged, AddressOf vsb_ValueChanged
            Controls.Remove(vsb)
            vsb = Nothing
        End If
        If theRows Is Nothing Then
            theRows = New Model10.RowCollection
        End If
        theRows.Clear() '        ǘ 
        totalWidth = 0 : totalHeight = 0
        totalRowCount = mChain.Count - 1

        Dim i As Integer
        For i = 0 To totalRowCount - 1
            Dim row As Model10.Row = GetRow(i)
            theRows.Add(row)

            totalHeight += row.Detail.Height
            If totalWidth < row.Detail.Table.Width + i * 16 Then
                totalWidth = row.Detail.Table.Width + i * 16
            End If
            row = Nothing
        Next

        theRowIndex = totalRowCount - 1
        Me.Height = totalHeight

        FillBody(0)
        OnResize(New EventArgs)
        SetRow(New Avand.Position(theRowIndex, ""))

        Me.Invalidate()
    End Sub
End Class